using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.Entity;
using System.Data.Entity.Core;
using System.Data.Entity.Core.EntityClient;
using System.Data.Entity.Core.Metadata.Edm;
using System.Data.Entity.Core.Objects;
using System.Data.Entity.Core.Objects.DataClasses;
using System.Diagnostics;
using System.Linq;
using System.Reflection;
using System.Runtime.Serialization;
using System.Xml.Serialization;
using InsERT.Mox.DataAccess;
using InsERT.Mox.DataAccess.EntityFramework;
using InsERT.Mox.DataBinding;
using InsERT.Mox.DataBinding.EntityFramework;
using InsERT.Mox.Validation;
using InsERT.Mox.Work;

#region assembly-level metadata

[assembly: EdmSchema]
[assembly: System.Runtime.InteropServices.ComVisible(false)]
[assembly: CLSCompliant(true)]

[assembly: AssemblyVersion("1.0.0.0")]
[assembly: EdmRelationship(
	"MoxDataModel",
	"FK_Products_Categories",
	"Categories",
	RelationshipMultiplicity.ZeroOrOne,
	typeof(MoxDataModel.Categories),
	"Products",
	RelationshipMultiplicity.Many,
	typeof(MoxDataModel.Products))]

[assembly: EdmRelationship(
	"MoxDataModel",
	"FK_Orders_Customers",
	"Customers",
	RelationshipMultiplicity.One,
	typeof(MoxDataModel.Customers),
	"Orders",
	RelationshipMultiplicity.Many,
	typeof(MoxDataModel.Orders))]

[assembly: EdmRelationship(
	"MoxDataModel",
	"FK_Employees_Employees",
	"Employees",
	RelationshipMultiplicity.ZeroOrOne,
	typeof(MoxDataModel.Employees),
	"Employees1",
	RelationshipMultiplicity.Many,
	typeof(MoxDataModel.Employees))]

[assembly: EdmRelationship(
	"MoxDataModel",
	"FK_Orders_Employees",
	"Employees",
	RelationshipMultiplicity.ZeroOrOne,
	typeof(MoxDataModel.Employees),
	"Orders",
	RelationshipMultiplicity.Many,
	typeof(MoxDataModel.Orders))]

[assembly: EdmRelationship(
	"MoxDataModel",
	"FK_Order_Details_Orders",
	"Orders",
	RelationshipMultiplicity.One,
	typeof(MoxDataModel.Orders),
	"Order_Details",
	RelationshipMultiplicity.Many,
	typeof(MoxDataModel.Order_Details))]

[assembly: EdmRelationship(
	"MoxDataModel",
	"FK_Order_Details_Products",
	"Products",
	RelationshipMultiplicity.One,
	typeof(MoxDataModel.Products),
	"Order_Details",
	RelationshipMultiplicity.Many,
	typeof(MoxDataModel.Order_Details))]

[assembly: EdmRelationship(
	"MoxDataModel",
	"FK_Orders_Shippers",
	"Shippers",
	RelationshipMultiplicity.ZeroOrOne,
	typeof(MoxDataModel.Shippers),
	"Orders",
	RelationshipMultiplicity.Many,
	typeof(MoxDataModel.Orders))]

[assembly: EdmRelationship(
	"MoxDataModel",
	"FK_Products_Suppliers",
	"Suppliers",
	RelationshipMultiplicity.ZeroOrOne,
	typeof(MoxDataModel.Suppliers),
	"Products",
	RelationshipMultiplicity.Many,
	typeof(MoxDataModel.Products))]

#endregion

namespace MoxDataModel
{
	#region entity types
/// <summary></summary>
/// <remarks></remarks>
	[EdmEntityType(NamespaceName = "MoxDataModel", Name = "Categories")]
    [Serializable]
    [DataContract(IsReference = true)]
	[System.CodeDom.Compiler.GeneratedCodeAttribute("InsERT.Mox.DataModeling.DataModelCSharpCodeGenerator", "1.0.0.0")]	
		public 	
	class Categories
		: EntityDataObjectBase
		, IIdentifiable<System.Int32>
	{
		#region type intitialization & runtime type information
		
		private static readonly System.Collections.Generic.Dictionary<string, RelationshipTraversalInfo> relationshipTraversalInfo = new RelationshipTraversalInfo[] 
		{
			FK_Products_CategoriesTraversalInfoStore.Categories,
		}.ToDictionary(rti => rti.NavigationPropertyName);
		
/// <summary>
/// Ta własność jest wykorzystywana przez wewnętrzne mechanizmy platformy Morii i nie powinna być bezpośrednio używana w kodzie zewnętrznym.
/// </summary>
        protected override IDictionary<string, RelationshipTraversalInfo> RelationshipTraversalInfo
        {
            get
            {
                return relationshipTraversalInfo;
            }
        }

/// <summary>
/// Ta własność jest wykorzystywana przez wewnętrzne mechanizmy platformy Morii i nie powinna być bezpośrednio używana w kodzie zewnętrznym.
/// </summary>
		protected override bool TryGetInfoForRelatedEndCore(IRelatedEnd relatedEnd, out RelationshipTraversalInfo info)
        {
			var relationshipManager = ((IEntityWithRelationships)this).RelationshipManager;
			if (false)
			{
			}
			else if (relatedEnd == relationshipManager.GetRelatedEnd("FK_Products_Categories", "Products"))
			{
				info = FK_Products_CategoriesTraversalInfoStore.Categories;
				return true;
			}
			else
			{            
            	info = null;
				return false;
			}
        }
		
		#endregion
	
		#region instance initialization

/// <summary>
/// Domyślny konstruktor <see cref="T:MoxDataModel.Categories" />.
/// </summary>
		public Categories()
		{
			ValidateCategoryID(_CategoryID);
			ValidateCategoryName(_CategoryName);
			ValidateDescription(_Description);
			ValidatePicture(_Picture);
		}
		
/// <summary>
/// Ta metoda jest wykorzystywana przez wewnętrzne mechanizmy platformy Morii i nie powinna być bezpośrednio używana w kodzie zewnętrznym.
/// </summary>
		protected override bool SubscribeToAssociationChangedEventsCore(string navigationProperty)
		{
			if (base.SubscribeToAssociationChangedEventsCore(navigationProperty))
			{
				if (navigationProperty == "Products")
				{
					var relatedEnd = ProductsRelatedEnd;
					ValidateProductsRelatedEnd(relatedEnd);
					relatedEnd.AssociationChanged += HandleProductsRelatedEndAssociationChanged;
					return false;
				}
				return true;
			}
			else
			{
				return false;
			}
		}
		#endregion

		#region relationship validation & change notification
		
		private void ValidateProductsRelatedEnd(EntityCollection<Products> relatedEnd)
		{
		}
		
		private void HandleProductsRelatedEndAssociationChanged(object sender, CollectionChangeEventArgs e)
		{
			DataErrorInfo.RemoveAllErrors("Products");
			var entityCollection = (EntityCollection<Products>)sender;
			ValidateProductsRelatedEnd(entityCollection);
			HandleImplicitAssociationChange(entityCollection, e, "Products");			
		}
		
		#endregion
	
		#region scalar property validation
		
		private void ValidateCategoryID(System.Int32 value)
		{
		}
		
		private void ValidateCategoryName(System.String value)
		{
			if (value == null)
			{
				DataErrorInfo.AddError(new MemberIsNullError(), "CategoryName");
			}
			if (value != null && value.Length > 15)
			{
				DataErrorInfo.AddError(new StringLengthError(15, false), "CategoryName");
			}
		}
		
		private void ValidateDescription(System.String value)
		{
			if (value == null)
			{
				DataErrorInfo.AddError(new MemberIsNullError(), "Description");
			}
		}
		
		private void ValidatePicture(System.Byte[] value)
		{
			if (value == null)
			{
				DataErrorInfo.AddError(new MemberIsNullError(), "Picture");
			}
		}
		
		#endregion
	
		#region explicit identifier accessor
		
		System.Int32 IIdentifiable<System.Int32>.Id
		{
			get
			{
				return CategoryID;
			}			
		}
		
		object IIdentifiable.Id
		{
			get
			{
				return CategoryID;
			}
		}
		
		Type IIdentifiable.IdType
		{
			get
			{
				return typeof(System.Int32);
			}
		}
		
		#endregion
	
		#region scalar properties
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.Int32 _CategoryID = default(System.Int32);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = true, IsNullable = false)]
		[DataMember]
		public System.Int32 CategoryID
		{
			get
			{
				return _CategoryID;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				DataErrorInfo.RemoveAllErrors("CategoryID");
				ReportScalarPropertyChanging(sink, "CategoryID", ref value);
				ValidateCategoryID(value);
				ReportPropertyChanging("CategoryID");
				_CategoryID = value;
				ReportPropertyChanged("CategoryID");
				ReportScalarPropertyChanged(sink, "CategoryID");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.String _CategoryName = default(System.String);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.String CategoryName
		{
			get
			{
				return _CategoryName;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "CategoryName");
				DataErrorInfo.RemoveAllErrors("CategoryName");
				ReportScalarPropertyChanging(sink, "CategoryName", ref value);
				ValidateCategoryName(value);
				ReportPropertyChanging("CategoryName");
				_CategoryName = value;
				ReportPropertyChanged("CategoryName");
				ReportScalarPropertyChanged(sink, "CategoryName");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.String _Description = default(System.String);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.String Description
		{
			get
			{
				return _Description;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "Description");
				DataErrorInfo.RemoveAllErrors("Description");
				ReportScalarPropertyChanging(sink, "Description", ref value);
				ValidateDescription(value);
				ReportPropertyChanging("Description");
				_Description = value;
				ReportPropertyChanged("Description");
				ReportScalarPropertyChanged(sink, "Description");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.Byte[] _Picture = default(System.Byte[]);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.Byte[] Picture
		{
			get
			{
				return _Picture;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "Picture");
				DataErrorInfo.RemoveAllErrors("Picture");
				ReportScalarPropertyChanging(sink, "Picture", ref value);
				ValidatePicture(value);
				ReportPropertyChanging("Picture");
				_Picture = value;
				ReportPropertyChanged("Picture");
				ReportScalarPropertyChanged(sink, "Picture");
			}
		}
		
		#endregion
		
		#region complex properties
		
		
		#endregion
		
		#region navigation properties
/// <summary>
/// Ta własność jest wykorzystywana przez wewnętrzne mechanizmy platformy Morii i nie powinna być bezpośrednio używana w kodzie zewnętrznym.
/// </summary>
		[DataMember]
		protected internal
		EntityCollection<Products> ProductsRelatedEnd
		{
			get
			{
				IEntityWithRelationships ewr = this;
				return ewr.RelationshipManager.GetRelatedCollection<Products>("FK_Products_Categories", "Products");
			}
			set
			{
				if (value != null)
				{
					IEntityWithRelationships ewr = this;
					ewr.RelationshipManager.InitializeRelatedCollection<Products>("FK_Products_Categories", "Products", value);
				}				
			}
		}
		
		internal object ProductsNoLazyLoading
		{
			get			
			{
				var context = ObjectContext;
				if (context == null || !context.ContextOption_LazyLoadingEnabled)
				{
					return Products;
				}
				else
				{
					try
					{
						context.ContextOption_LazyLoadingEnabled = false;
						return Products.ToArray();
					}
					finally
					{
						context.ContextOption_LazyLoadingEnabled = true;
					}
				}
			}
		}
		
		private WrappedEntityCollection<Products> _wrappedProducts;

		private WrappedEntityCollection<Products> WrappedProducts
		{
			get
			{
				if (_wrappedProducts == null)
				{
					_wrappedProducts = new WrappedEntityCollection<Products>(this, "Products", "Categories");
				}
				_wrappedProducts.UnderlyingEntityCollection = ProductsRelatedEnd;
				return _wrappedProducts;
			}
		}
		

/// <summary></summary>
/// <remarks></remarks>
		[EdmRelationshipNavigationProperty("MoxDataModel", "FK_Products_Categories", "Products")]
		[XmlIgnore]
		[SoapIgnore]
		public
		ICollection<Products> Products
		{
			get
			{
				return WrappedProducts;
			}
		}						
		#endregion
	}
/// <summary></summary>
/// <remarks></remarks>
	[EdmEntityType(NamespaceName = "MoxDataModel", Name = "Customers")]
    [Serializable]
    [DataContract(IsReference = true)]
	[System.CodeDom.Compiler.GeneratedCodeAttribute("InsERT.Mox.DataModeling.DataModelCSharpCodeGenerator", "1.0.0.0")]	
		public 	
	class Customers
		: EntityDataObjectBase
		, IIdentifiable<System.String>
	{
		#region type intitialization & runtime type information
		
		private static readonly System.Collections.Generic.Dictionary<string, RelationshipTraversalInfo> relationshipTraversalInfo = new RelationshipTraversalInfo[] 
		{
			FK_Orders_CustomersTraversalInfoStore.Customers,
		}.ToDictionary(rti => rti.NavigationPropertyName);
		
/// <summary>
/// Ta własność jest wykorzystywana przez wewnętrzne mechanizmy platformy Morii i nie powinna być bezpośrednio używana w kodzie zewnętrznym.
/// </summary>
        protected override IDictionary<string, RelationshipTraversalInfo> RelationshipTraversalInfo
        {
            get
            {
                return relationshipTraversalInfo;
            }
        }

/// <summary>
/// Ta własność jest wykorzystywana przez wewnętrzne mechanizmy platformy Morii i nie powinna być bezpośrednio używana w kodzie zewnętrznym.
/// </summary>
		protected override bool TryGetInfoForRelatedEndCore(IRelatedEnd relatedEnd, out RelationshipTraversalInfo info)
        {
			var relationshipManager = ((IEntityWithRelationships)this).RelationshipManager;
			if (false)
			{
			}
			else if (relatedEnd == relationshipManager.GetRelatedEnd("FK_Orders_Customers", "Orders"))
			{
				info = FK_Orders_CustomersTraversalInfoStore.Customers;
				return true;
			}
			else
			{            
            	info = null;
				return false;
			}
        }
		
		#endregion
	
		#region instance initialization

/// <summary>
/// Domyślny konstruktor <see cref="T:MoxDataModel.Customers" />.
/// </summary>
		public Customers()
		{
			ValidateCustomerID(_CustomerID);
			ValidateCompanyName(_CompanyName);
			ValidateContactName(_ContactName);
			ValidateContactTitle(_ContactTitle);
			ValidateAddress(_Address);
			ValidateCity(_City);
			ValidateRegion(_Region);
			ValidatePostalCode(_PostalCode);
			ValidateCountry(_Country);
			ValidatePhone(_Phone);
			ValidateFax(_Fax);
		}
		
/// <summary>
/// Ta metoda jest wykorzystywana przez wewnętrzne mechanizmy platformy Morii i nie powinna być bezpośrednio używana w kodzie zewnętrznym.
/// </summary>
		protected override bool SubscribeToAssociationChangedEventsCore(string navigationProperty)
		{
			if (base.SubscribeToAssociationChangedEventsCore(navigationProperty))
			{
				if (navigationProperty == "Orders")
				{
					var relatedEnd = OrdersRelatedEnd;
					ValidateOrdersRelatedEnd(relatedEnd);
					relatedEnd.AssociationChanged += HandleOrdersRelatedEndAssociationChanged;
					return false;
				}
				return true;
			}
			else
			{
				return false;
			}
		}
		#endregion

		#region relationship validation & change notification
		
		private void ValidateOrdersRelatedEnd(EntityCollection<Orders> relatedEnd)
		{
		}
		
		private void HandleOrdersRelatedEndAssociationChanged(object sender, CollectionChangeEventArgs e)
		{
			DataErrorInfo.RemoveAllErrors("Orders");
			var entityCollection = (EntityCollection<Orders>)sender;
			ValidateOrdersRelatedEnd(entityCollection);
			HandleImplicitAssociationChange(entityCollection, e, "Orders");			
		}
		
		#endregion
	
		#region scalar property validation
		
		private void ValidateCustomerID(System.String value)
		{
			if (value == null)
			{
				DataErrorInfo.AddError(new MemberIsNullError(), "CustomerID");
			}
			if (value != null && value.Length != 5)
			{
				DataErrorInfo.AddError(new StringLengthError(5, 5), "CustomerID");
			}
		}
		
		private void ValidateCompanyName(System.String value)
		{
			if (value == null)
			{
				DataErrorInfo.AddError(new MemberIsNullError(), "CompanyName");
			}
			if (value != null && value.Length > 40)
			{
				DataErrorInfo.AddError(new StringLengthError(40, false), "CompanyName");
			}
		}
		
		private void ValidateContactName(System.String value)
		{
			if (value == null)
			{
				DataErrorInfo.AddError(new MemberIsNullError(), "ContactName");
			}
			if (value != null && value.Length > 30)
			{
				DataErrorInfo.AddError(new StringLengthError(30, false), "ContactName");
			}
		}
		
		private void ValidateContactTitle(System.String value)
		{
			if (value == null)
			{
				DataErrorInfo.AddError(new MemberIsNullError(), "ContactTitle");
			}
			if (value != null && value.Length > 30)
			{
				DataErrorInfo.AddError(new StringLengthError(30, false), "ContactTitle");
			}
		}
		
		private void ValidateAddress(System.String value)
		{
			if (value == null)
			{
				DataErrorInfo.AddError(new MemberIsNullError(), "Address");
			}
			if (value != null && value.Length > 60)
			{
				DataErrorInfo.AddError(new StringLengthError(60, false), "Address");
			}
		}
		
		private void ValidateCity(System.String value)
		{
			if (value == null)
			{
				DataErrorInfo.AddError(new MemberIsNullError(), "City");
			}
			if (value != null && value.Length > 15)
			{
				DataErrorInfo.AddError(new StringLengthError(15, false), "City");
			}
		}
		
		private void ValidateRegion(System.String value)
		{
			if (value == null)
			{
				DataErrorInfo.AddError(new MemberIsNullError(), "Region");
			}
			if (value != null && value.Length > 15)
			{
				DataErrorInfo.AddError(new StringLengthError(15, false), "Region");
			}
		}
		
		private void ValidatePostalCode(System.String value)
		{
			if (value == null)
			{
				DataErrorInfo.AddError(new MemberIsNullError(), "PostalCode");
			}
			if (value != null && value.Length > 10)
			{
				DataErrorInfo.AddError(new StringLengthError(10, false), "PostalCode");
			}
		}
		
		private void ValidateCountry(System.String value)
		{
			if (value == null)
			{
				DataErrorInfo.AddError(new MemberIsNullError(), "Country");
			}
			if (value != null && value.Length > 15)
			{
				DataErrorInfo.AddError(new StringLengthError(15, false), "Country");
			}
		}
		
		private void ValidatePhone(System.String value)
		{
			if (value == null)
			{
				DataErrorInfo.AddError(new MemberIsNullError(), "Phone");
			}
			if (value != null && value.Length > 24)
			{
				DataErrorInfo.AddError(new StringLengthError(24, false), "Phone");
			}
		}
		
		private void ValidateFax(System.String value)
		{
			if (value == null)
			{
				DataErrorInfo.AddError(new MemberIsNullError(), "Fax");
			}
			if (value != null && value.Length > 24)
			{
				DataErrorInfo.AddError(new StringLengthError(24, false), "Fax");
			}
		}
		
		#endregion
	
		#region explicit identifier accessor
		
		System.String IIdentifiable<System.String>.Id
		{
			get
			{
				return CustomerID;
			}			
		}
		
		object IIdentifiable.Id
		{
			get
			{
				return CustomerID;
			}
		}
		
		Type IIdentifiable.IdType
		{
			get
			{
				return typeof(System.String);
			}
		}
		
		#endregion
	
		#region scalar properties
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.String _CustomerID = default(System.String);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = true, IsNullable = false)]
		[DataMember]
		public System.String CustomerID
		{
			get
			{
				return _CustomerID;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "CustomerID");
				DataErrorInfo.RemoveAllErrors("CustomerID");
				ReportScalarPropertyChanging(sink, "CustomerID", ref value);
				ValidateCustomerID(value);
				ReportPropertyChanging("CustomerID");
				_CustomerID = value;
				ReportPropertyChanged("CustomerID");
				ReportScalarPropertyChanged(sink, "CustomerID");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.String _CompanyName = default(System.String);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.String CompanyName
		{
			get
			{
				return _CompanyName;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "CompanyName");
				DataErrorInfo.RemoveAllErrors("CompanyName");
				ReportScalarPropertyChanging(sink, "CompanyName", ref value);
				ValidateCompanyName(value);
				ReportPropertyChanging("CompanyName");
				_CompanyName = value;
				ReportPropertyChanged("CompanyName");
				ReportScalarPropertyChanged(sink, "CompanyName");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.String _ContactName = default(System.String);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.String ContactName
		{
			get
			{
				return _ContactName;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "ContactName");
				DataErrorInfo.RemoveAllErrors("ContactName");
				ReportScalarPropertyChanging(sink, "ContactName", ref value);
				ValidateContactName(value);
				ReportPropertyChanging("ContactName");
				_ContactName = value;
				ReportPropertyChanged("ContactName");
				ReportScalarPropertyChanged(sink, "ContactName");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.String _ContactTitle = default(System.String);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.String ContactTitle
		{
			get
			{
				return _ContactTitle;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "ContactTitle");
				DataErrorInfo.RemoveAllErrors("ContactTitle");
				ReportScalarPropertyChanging(sink, "ContactTitle", ref value);
				ValidateContactTitle(value);
				ReportPropertyChanging("ContactTitle");
				_ContactTitle = value;
				ReportPropertyChanged("ContactTitle");
				ReportScalarPropertyChanged(sink, "ContactTitle");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.String _Address = default(System.String);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.String Address
		{
			get
			{
				return _Address;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "Address");
				DataErrorInfo.RemoveAllErrors("Address");
				ReportScalarPropertyChanging(sink, "Address", ref value);
				ValidateAddress(value);
				ReportPropertyChanging("Address");
				_Address = value;
				ReportPropertyChanged("Address");
				ReportScalarPropertyChanged(sink, "Address");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.String _City = default(System.String);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.String City
		{
			get
			{
				return _City;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "City");
				DataErrorInfo.RemoveAllErrors("City");
				ReportScalarPropertyChanging(sink, "City", ref value);
				ValidateCity(value);
				ReportPropertyChanging("City");
				_City = value;
				ReportPropertyChanged("City");
				ReportScalarPropertyChanged(sink, "City");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.String _Region = default(System.String);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.String Region
		{
			get
			{
				return _Region;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "Region");
				DataErrorInfo.RemoveAllErrors("Region");
				ReportScalarPropertyChanging(sink, "Region", ref value);
				ValidateRegion(value);
				ReportPropertyChanging("Region");
				_Region = value;
				ReportPropertyChanged("Region");
				ReportScalarPropertyChanged(sink, "Region");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.String _PostalCode = default(System.String);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.String PostalCode
		{
			get
			{
				return _PostalCode;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "PostalCode");
				DataErrorInfo.RemoveAllErrors("PostalCode");
				ReportScalarPropertyChanging(sink, "PostalCode", ref value);
				ValidatePostalCode(value);
				ReportPropertyChanging("PostalCode");
				_PostalCode = value;
				ReportPropertyChanged("PostalCode");
				ReportScalarPropertyChanged(sink, "PostalCode");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.String _Country = default(System.String);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.String Country
		{
			get
			{
				return _Country;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "Country");
				DataErrorInfo.RemoveAllErrors("Country");
				ReportScalarPropertyChanging(sink, "Country", ref value);
				ValidateCountry(value);
				ReportPropertyChanging("Country");
				_Country = value;
				ReportPropertyChanged("Country");
				ReportScalarPropertyChanged(sink, "Country");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.String _Phone = default(System.String);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.String Phone
		{
			get
			{
				return _Phone;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "Phone");
				DataErrorInfo.RemoveAllErrors("Phone");
				ReportScalarPropertyChanging(sink, "Phone", ref value);
				ValidatePhone(value);
				ReportPropertyChanging("Phone");
				_Phone = value;
				ReportPropertyChanged("Phone");
				ReportScalarPropertyChanged(sink, "Phone");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.String _Fax = default(System.String);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.String Fax
		{
			get
			{
				return _Fax;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "Fax");
				DataErrorInfo.RemoveAllErrors("Fax");
				ReportScalarPropertyChanging(sink, "Fax", ref value);
				ValidateFax(value);
				ReportPropertyChanging("Fax");
				_Fax = value;
				ReportPropertyChanged("Fax");
				ReportScalarPropertyChanged(sink, "Fax");
			}
		}
		
		#endregion
		
		#region complex properties
		
		
		#endregion
		
		#region navigation properties
/// <summary>
/// Ta własność jest wykorzystywana przez wewnętrzne mechanizmy platformy Morii i nie powinna być bezpośrednio używana w kodzie zewnętrznym.
/// </summary>
		[DataMember]
		protected internal
		EntityCollection<Orders> OrdersRelatedEnd
		{
			get
			{
				IEntityWithRelationships ewr = this;
				return ewr.RelationshipManager.GetRelatedCollection<Orders>("FK_Orders_Customers", "Orders");
			}
			set
			{
				if (value != null)
				{
					IEntityWithRelationships ewr = this;
					ewr.RelationshipManager.InitializeRelatedCollection<Orders>("FK_Orders_Customers", "Orders", value);
				}				
			}
		}
		
		internal object OrdersNoLazyLoading
		{
			get			
			{
				var context = ObjectContext;
				if (context == null || !context.ContextOption_LazyLoadingEnabled)
				{
					return Orders;
				}
				else
				{
					try
					{
						context.ContextOption_LazyLoadingEnabled = false;
						return Orders.ToArray();
					}
					finally
					{
						context.ContextOption_LazyLoadingEnabled = true;
					}
				}
			}
		}
		
		private WrappedEntityCollection<Orders> _wrappedOrders;

		private WrappedEntityCollection<Orders> WrappedOrders
		{
			get
			{
				if (_wrappedOrders == null)
				{
					_wrappedOrders = new WrappedEntityCollection<Orders>(this, "Orders", "Customers");
				}
				_wrappedOrders.UnderlyingEntityCollection = OrdersRelatedEnd;
				return _wrappedOrders;
			}
		}
		

/// <summary></summary>
/// <remarks></remarks>
		[EdmRelationshipNavigationProperty("MoxDataModel", "FK_Orders_Customers", "Orders")]
		[XmlIgnore]
		[SoapIgnore]
		public
		ICollection<Orders> Orders
		{
			get
			{
				return WrappedOrders;
			}
		}						
		#endregion
	}
/// <summary></summary>
/// <remarks></remarks>
	[EdmEntityType(NamespaceName = "MoxDataModel", Name = "Employees")]
    [Serializable]
    [DataContract(IsReference = true)]
	[System.CodeDom.Compiler.GeneratedCodeAttribute("InsERT.Mox.DataModeling.DataModelCSharpCodeGenerator", "1.0.0.0")]	
		public 	
	class Employees
		: EntityDataObjectBase
		, IIdentifiable<System.Int32>
	{
		#region type intitialization & runtime type information
		
		private static readonly System.Collections.Generic.Dictionary<string, RelationshipTraversalInfo> relationshipTraversalInfo = new RelationshipTraversalInfo[] 
		{
			FK_Employees_EmployeesTraversalInfoStore.Employees,
			FK_Employees_EmployeesTraversalInfoStore.Employees1,
			FK_Orders_EmployeesTraversalInfoStore.Employees,
		}.ToDictionary(rti => rti.NavigationPropertyName);
		
/// <summary>
/// Ta własność jest wykorzystywana przez wewnętrzne mechanizmy platformy Morii i nie powinna być bezpośrednio używana w kodzie zewnętrznym.
/// </summary>
        protected override IDictionary<string, RelationshipTraversalInfo> RelationshipTraversalInfo
        {
            get
            {
                return relationshipTraversalInfo;
            }
        }

/// <summary>
/// Ta własność jest wykorzystywana przez wewnętrzne mechanizmy platformy Morii i nie powinna być bezpośrednio używana w kodzie zewnętrznym.
/// </summary>
		protected override bool TryGetInfoForRelatedEndCore(IRelatedEnd relatedEnd, out RelationshipTraversalInfo info)
        {
			var relationshipManager = ((IEntityWithRelationships)this).RelationshipManager;
			if (false)
			{
			}
			else if (relatedEnd == relationshipManager.GetRelatedEnd("FK_Employees_Employees", "Employees1"))
			{
				info = FK_Employees_EmployeesTraversalInfoStore.Employees;
				return true;
			}
			else if (relatedEnd == relationshipManager.GetRelatedEnd("FK_Employees_Employees", "Employees"))
			{
				info = FK_Employees_EmployeesTraversalInfoStore.Employees1;
				return true;
			}
			else if (relatedEnd == relationshipManager.GetRelatedEnd("FK_Orders_Employees", "Orders"))
			{
				info = FK_Orders_EmployeesTraversalInfoStore.Employees;
				return true;
			}
			else
			{            
            	info = null;
				return false;
			}
        }
		
		#endregion
	
		#region instance initialization

/// <summary>
/// Domyślny konstruktor <see cref="T:MoxDataModel.Employees" />.
/// </summary>
		public Employees()
		{
			ValidateEmployeeID(_EmployeeID);
			ValidateLastName(_LastName);
			ValidateFirstName(_FirstName);
			ValidateTitle(_Title);
			ValidateTitleOfCourtesy(_TitleOfCourtesy);
			ValidateBirthDate(_BirthDate);
			ValidateHireDate(_HireDate);
			ValidateAddress(_Address);
			ValidateCity(_City);
			ValidateRegion(_Region);
			ValidatePostalCode(_PostalCode);
			ValidateCountry(_Country);
			ValidateHomePhone(_HomePhone);
			ValidateExtension(_Extension);
			ValidatePhoto(_Photo);
			ValidateNotes(_Notes);
			ValidateReportsTo(_ReportsTo);
			ValidatePhotoPath(_PhotoPath);
		}
		
/// <summary>
/// Ta metoda jest wykorzystywana przez wewnętrzne mechanizmy platformy Morii i nie powinna być bezpośrednio używana w kodzie zewnętrznym.
/// </summary>
		protected override bool SubscribeToAssociationChangedEventsCore(string navigationProperty)
		{
			if (base.SubscribeToAssociationChangedEventsCore(navigationProperty))
			{
				if (navigationProperty == "Employees1")
				{
					var relatedEnd = Employees1RelatedEnd;
					ValidateEmployees1RelatedEnd(relatedEnd);
					relatedEnd.AssociationChanged += HandleEmployees1RelatedEndAssociationChanged;
					return false;
				}
				if (navigationProperty == "Employees2")
				{
					var relatedEnd = Employees2RelatedEnd;
					ValidateEmployees2RelatedEnd(relatedEnd);
					relatedEnd.AssociationChanged += HandleEmployees2RelatedEndAssociationChanged;
					return false;
				}
				if (navigationProperty == "Orders")
				{
					var relatedEnd = OrdersRelatedEnd;
					ValidateOrdersRelatedEnd(relatedEnd);
					relatedEnd.AssociationChanged += HandleOrdersRelatedEndAssociationChanged;
					return false;
				}
				return true;
			}
			else
			{
				return false;
			}
		}
		#endregion

		#region relationship validation & change notification
		
		private void ValidateEmployees1RelatedEnd(EntityCollection<Employees> relatedEnd)
		{
		}
		
		private void HandleEmployees1RelatedEndAssociationChanged(object sender, CollectionChangeEventArgs e)
		{
			DataErrorInfo.RemoveAllErrors("Employees1");
			var entityCollection = (EntityCollection<Employees>)sender;
			ValidateEmployees1RelatedEnd(entityCollection);
			HandleImplicitAssociationChange(entityCollection, e, "Employees1");			
		}
		
		private void ValidateEmployees2RelatedEnd(EntityReference<Employees> relatedEnd)
		{			
		}
		
		private void HandleEmployees2RelatedEndAssociationChanged(object sender, CollectionChangeEventArgs e)
		{
			DataErrorInfo.RemoveAllErrors("Employees2");
			var entityReference = (EntityReference<Employees>)sender;
			ValidateEmployees2RelatedEnd(entityReference);
			HandleImplicitAssociationChange(entityReference, e, "Employees2");
		}
		
		private void ValidateOrdersRelatedEnd(EntityCollection<Orders> relatedEnd)
		{
		}
		
		private void HandleOrdersRelatedEndAssociationChanged(object sender, CollectionChangeEventArgs e)
		{
			DataErrorInfo.RemoveAllErrors("Orders");
			var entityCollection = (EntityCollection<Orders>)sender;
			ValidateOrdersRelatedEnd(entityCollection);
			HandleImplicitAssociationChange(entityCollection, e, "Orders");			
		}
		
		#endregion
	
		#region scalar property validation
		
		private void ValidateEmployeeID(System.Int32 value)
		{
		}
		
		private void ValidateLastName(System.String value)
		{
			if (value == null)
			{
				DataErrorInfo.AddError(new MemberIsNullError(), "LastName");
			}
			if (value != null && value.Length > 20)
			{
				DataErrorInfo.AddError(new StringLengthError(20, false), "LastName");
			}
		}
		
		private void ValidateFirstName(System.String value)
		{
			if (value == null)
			{
				DataErrorInfo.AddError(new MemberIsNullError(), "FirstName");
			}
			if (value != null && value.Length > 10)
			{
				DataErrorInfo.AddError(new StringLengthError(10, false), "FirstName");
			}
		}
		
		private void ValidateTitle(System.String value)
		{
			if (value == null)
			{
				DataErrorInfo.AddError(new MemberIsNullError(), "Title");
			}
			if (value != null && value.Length > 30)
			{
				DataErrorInfo.AddError(new StringLengthError(30, false), "Title");
			}
		}
		
		private void ValidateTitleOfCourtesy(System.String value)
		{
			if (value == null)
			{
				DataErrorInfo.AddError(new MemberIsNullError(), "TitleOfCourtesy");
			}
			if (value != null && value.Length > 25)
			{
				DataErrorInfo.AddError(new StringLengthError(25, false), "TitleOfCourtesy");
			}
		}
		
		private void ValidateBirthDate(System.DateTime value)
		{
		}
		
		private void ValidateHireDate(System.DateTime value)
		{
		}
		
		private void ValidateAddress(System.String value)
		{
			if (value == null)
			{
				DataErrorInfo.AddError(new MemberIsNullError(), "Address");
			}
			if (value != null && value.Length > 60)
			{
				DataErrorInfo.AddError(new StringLengthError(60, false), "Address");
			}
		}
		
		private void ValidateCity(System.String value)
		{
			if (value == null)
			{
				DataErrorInfo.AddError(new MemberIsNullError(), "City");
			}
			if (value != null && value.Length > 15)
			{
				DataErrorInfo.AddError(new StringLengthError(15, false), "City");
			}
		}
		
		private void ValidateRegion(System.String value)
		{
			if (value == null)
			{
				DataErrorInfo.AddError(new MemberIsNullError(), "Region");
			}
			if (value != null && value.Length > 15)
			{
				DataErrorInfo.AddError(new StringLengthError(15, false), "Region");
			}
		}
		
		private void ValidatePostalCode(System.String value)
		{
			if (value == null)
			{
				DataErrorInfo.AddError(new MemberIsNullError(), "PostalCode");
			}
			if (value != null && value.Length > 10)
			{
				DataErrorInfo.AddError(new StringLengthError(10, false), "PostalCode");
			}
		}
		
		private void ValidateCountry(System.String value)
		{
			if (value == null)
			{
				DataErrorInfo.AddError(new MemberIsNullError(), "Country");
			}
			if (value != null && value.Length > 15)
			{
				DataErrorInfo.AddError(new StringLengthError(15, false), "Country");
			}
		}
		
		private void ValidateHomePhone(System.String value)
		{
			if (value == null)
			{
				DataErrorInfo.AddError(new MemberIsNullError(), "HomePhone");
			}
			if (value != null && value.Length > 24)
			{
				DataErrorInfo.AddError(new StringLengthError(24, false), "HomePhone");
			}
		}
		
		private void ValidateExtension(System.String value)
		{
			if (value == null)
			{
				DataErrorInfo.AddError(new MemberIsNullError(), "Extension");
			}
			if (value != null && value.Length > 4)
			{
				DataErrorInfo.AddError(new StringLengthError(4, false), "Extension");
			}
		}
		
		private void ValidatePhoto(System.Byte[] value)
		{
			if (value == null)
			{
				DataErrorInfo.AddError(new MemberIsNullError(), "Photo");
			}
		}
		
		private void ValidateNotes(System.String value)
		{
			if (value == null)
			{
				DataErrorInfo.AddError(new MemberIsNullError(), "Notes");
			}
		}
		
		private void ValidateReportsTo(System.Int32? value)
		{
		}
		
		private void ValidatePhotoPath(System.String value)
		{
			if (value == null)
			{
				DataErrorInfo.AddError(new MemberIsNullError(), "PhotoPath");
			}
			if (value != null && value.Length > 255)
			{
				DataErrorInfo.AddError(new StringLengthError(255, false), "PhotoPath");
			}
		}
		
		#endregion
	
		#region explicit identifier accessor
		
		System.Int32 IIdentifiable<System.Int32>.Id
		{
			get
			{
				return EmployeeID;
			}			
		}
		
		object IIdentifiable.Id
		{
			get
			{
				return EmployeeID;
			}
		}
		
		Type IIdentifiable.IdType
		{
			get
			{
				return typeof(System.Int32);
			}
		}
		
		#endregion
	
		#region scalar properties
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.Int32 _EmployeeID = default(System.Int32);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = true, IsNullable = false)]
		[DataMember]
		public System.Int32 EmployeeID
		{
			get
			{
				return _EmployeeID;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				DataErrorInfo.RemoveAllErrors("EmployeeID");
				ReportScalarPropertyChanging(sink, "EmployeeID", ref value);
				ValidateEmployeeID(value);
				ReportPropertyChanging("EmployeeID");
				_EmployeeID = value;
				ReportPropertyChanged("EmployeeID");
				ReportScalarPropertyChanged(sink, "EmployeeID");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.String _LastName = default(System.String);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.String LastName
		{
			get
			{
				return _LastName;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "LastName");
				DataErrorInfo.RemoveAllErrors("LastName");
				ReportScalarPropertyChanging(sink, "LastName", ref value);
				ValidateLastName(value);
				ReportPropertyChanging("LastName");
				_LastName = value;
				ReportPropertyChanged("LastName");
				ReportScalarPropertyChanged(sink, "LastName");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.String _FirstName = default(System.String);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.String FirstName
		{
			get
			{
				return _FirstName;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "FirstName");
				DataErrorInfo.RemoveAllErrors("FirstName");
				ReportScalarPropertyChanging(sink, "FirstName", ref value);
				ValidateFirstName(value);
				ReportPropertyChanging("FirstName");
				_FirstName = value;
				ReportPropertyChanged("FirstName");
				ReportScalarPropertyChanged(sink, "FirstName");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.String _Title = default(System.String);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.String Title
		{
			get
			{
				return _Title;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "Title");
				DataErrorInfo.RemoveAllErrors("Title");
				ReportScalarPropertyChanging(sink, "Title", ref value);
				ValidateTitle(value);
				ReportPropertyChanging("Title");
				_Title = value;
				ReportPropertyChanged("Title");
				ReportScalarPropertyChanged(sink, "Title");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.String _TitleOfCourtesy = default(System.String);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.String TitleOfCourtesy
		{
			get
			{
				return _TitleOfCourtesy;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "TitleOfCourtesy");
				DataErrorInfo.RemoveAllErrors("TitleOfCourtesy");
				ReportScalarPropertyChanging(sink, "TitleOfCourtesy", ref value);
				ValidateTitleOfCourtesy(value);
				ReportPropertyChanging("TitleOfCourtesy");
				_TitleOfCourtesy = value;
				ReportPropertyChanged("TitleOfCourtesy");
				ReportScalarPropertyChanged(sink, "TitleOfCourtesy");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.DateTime _BirthDate = default(System.DateTime);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.DateTime BirthDate
		{
			get
			{
				return _BirthDate;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "BirthDate");
				DataErrorInfo.RemoveAllErrors("BirthDate");
				ReportScalarPropertyChanging(sink, "BirthDate", ref value);
				ValidateBirthDate(value);
				ReportPropertyChanging("BirthDate");
				_BirthDate = value;
				ReportPropertyChanged("BirthDate");
				ReportScalarPropertyChanged(sink, "BirthDate");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.DateTime _HireDate = default(System.DateTime);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.DateTime HireDate
		{
			get
			{
				return _HireDate;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "HireDate");
				DataErrorInfo.RemoveAllErrors("HireDate");
				ReportScalarPropertyChanging(sink, "HireDate", ref value);
				ValidateHireDate(value);
				ReportPropertyChanging("HireDate");
				_HireDate = value;
				ReportPropertyChanged("HireDate");
				ReportScalarPropertyChanged(sink, "HireDate");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.String _Address = default(System.String);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.String Address
		{
			get
			{
				return _Address;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "Address");
				DataErrorInfo.RemoveAllErrors("Address");
				ReportScalarPropertyChanging(sink, "Address", ref value);
				ValidateAddress(value);
				ReportPropertyChanging("Address");
				_Address = value;
				ReportPropertyChanged("Address");
				ReportScalarPropertyChanged(sink, "Address");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.String _City = default(System.String);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.String City
		{
			get
			{
				return _City;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "City");
				DataErrorInfo.RemoveAllErrors("City");
				ReportScalarPropertyChanging(sink, "City", ref value);
				ValidateCity(value);
				ReportPropertyChanging("City");
				_City = value;
				ReportPropertyChanged("City");
				ReportScalarPropertyChanged(sink, "City");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.String _Region = default(System.String);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.String Region
		{
			get
			{
				return _Region;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "Region");
				DataErrorInfo.RemoveAllErrors("Region");
				ReportScalarPropertyChanging(sink, "Region", ref value);
				ValidateRegion(value);
				ReportPropertyChanging("Region");
				_Region = value;
				ReportPropertyChanged("Region");
				ReportScalarPropertyChanged(sink, "Region");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.String _PostalCode = default(System.String);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.String PostalCode
		{
			get
			{
				return _PostalCode;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "PostalCode");
				DataErrorInfo.RemoveAllErrors("PostalCode");
				ReportScalarPropertyChanging(sink, "PostalCode", ref value);
				ValidatePostalCode(value);
				ReportPropertyChanging("PostalCode");
				_PostalCode = value;
				ReportPropertyChanged("PostalCode");
				ReportScalarPropertyChanged(sink, "PostalCode");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.String _Country = default(System.String);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.String Country
		{
			get
			{
				return _Country;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "Country");
				DataErrorInfo.RemoveAllErrors("Country");
				ReportScalarPropertyChanging(sink, "Country", ref value);
				ValidateCountry(value);
				ReportPropertyChanging("Country");
				_Country = value;
				ReportPropertyChanged("Country");
				ReportScalarPropertyChanged(sink, "Country");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.String _HomePhone = default(System.String);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.String HomePhone
		{
			get
			{
				return _HomePhone;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "HomePhone");
				DataErrorInfo.RemoveAllErrors("HomePhone");
				ReportScalarPropertyChanging(sink, "HomePhone", ref value);
				ValidateHomePhone(value);
				ReportPropertyChanging("HomePhone");
				_HomePhone = value;
				ReportPropertyChanged("HomePhone");
				ReportScalarPropertyChanged(sink, "HomePhone");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.String _Extension = default(System.String);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.String Extension
		{
			get
			{
				return _Extension;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "Extension");
				DataErrorInfo.RemoveAllErrors("Extension");
				ReportScalarPropertyChanging(sink, "Extension", ref value);
				ValidateExtension(value);
				ReportPropertyChanging("Extension");
				_Extension = value;
				ReportPropertyChanged("Extension");
				ReportScalarPropertyChanged(sink, "Extension");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.Byte[] _Photo = default(System.Byte[]);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.Byte[] Photo
		{
			get
			{
				return _Photo;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "Photo");
				DataErrorInfo.RemoveAllErrors("Photo");
				ReportScalarPropertyChanging(sink, "Photo", ref value);
				ValidatePhoto(value);
				ReportPropertyChanging("Photo");
				_Photo = value;
				ReportPropertyChanged("Photo");
				ReportScalarPropertyChanged(sink, "Photo");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.String _Notes = default(System.String);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.String Notes
		{
			get
			{
				return _Notes;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "Notes");
				DataErrorInfo.RemoveAllErrors("Notes");
				ReportScalarPropertyChanging(sink, "Notes", ref value);
				ValidateNotes(value);
				ReportPropertyChanging("Notes");
				_Notes = value;
				ReportPropertyChanged("Notes");
				ReportScalarPropertyChanged(sink, "Notes");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.Int32? _ReportsTo = default(System.Int32?);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = true)]
		[DataMember]
		public System.Int32? ReportsTo
		{
			get
			{
				return _ReportsTo;
			}

			internal
			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				DataErrorInfo.RemoveAllErrors("ReportsTo");
				ValidateReportsTo(value);
				ReportPropertyChanging("ReportsTo");
				_ReportsTo = value;
				ReportPropertyChanged("ReportsTo");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.String _PhotoPath = default(System.String);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.String PhotoPath
		{
			get
			{
				return _PhotoPath;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "PhotoPath");
				DataErrorInfo.RemoveAllErrors("PhotoPath");
				ReportScalarPropertyChanging(sink, "PhotoPath", ref value);
				ValidatePhotoPath(value);
				ReportPropertyChanging("PhotoPath");
				_PhotoPath = value;
				ReportPropertyChanged("PhotoPath");
				ReportScalarPropertyChanged(sink, "PhotoPath");
			}
		}
		
		#endregion
		
		#region complex properties
		
		
		#endregion
		
		#region navigation properties
/// <summary>
/// Ta własność jest wykorzystywana przez wewnętrzne mechanizmy platformy Morii i nie powinna być bezpośrednio używana w kodzie zewnętrznym.
/// </summary>
		[DataMember]
		protected internal
		EntityCollection<Employees> Employees1RelatedEnd
		{
			get
			{
				IEntityWithRelationships ewr = this;
				return ewr.RelationshipManager.GetRelatedCollection<Employees>("FK_Employees_Employees", "Employees1");
			}
			set
			{
				if (value != null)
				{
					IEntityWithRelationships ewr = this;
					ewr.RelationshipManager.InitializeRelatedCollection<Employees>("FK_Employees_Employees", "Employees1", value);
				}				
			}
		}
		
		internal object Employees1NoLazyLoading
		{
			get			
			{
				var context = ObjectContext;
				if (context == null || !context.ContextOption_LazyLoadingEnabled)
				{
					return Employees1;
				}
				else
				{
					try
					{
						context.ContextOption_LazyLoadingEnabled = false;
						return Employees1.ToArray();
					}
					finally
					{
						context.ContextOption_LazyLoadingEnabled = true;
					}
				}
			}
		}
		
		private WrappedEntityCollection<Employees> _wrappedEmployees1;

		private WrappedEntityCollection<Employees> WrappedEmployees1
		{
			get
			{
				if (_wrappedEmployees1 == null)
				{
					_wrappedEmployees1 = new WrappedEntityCollection<Employees>(this, "Employees1", "Employees2");
				}
				_wrappedEmployees1.UnderlyingEntityCollection = Employees1RelatedEnd;
				return _wrappedEmployees1;
			}
		}
		

/// <summary></summary>
/// <remarks></remarks>
		[EdmRelationshipNavigationProperty("MoxDataModel", "FK_Employees_Employees", "Employees1")]
		[XmlIgnore]
		[SoapIgnore]
		public
		ICollection<Employees> Employees1
		{
			get
			{
				return WrappedEmployees1;
			}
		}						
/// <summary>
/// Ta własność jest wykorzystywana przez wewnętrzne mechanizmy platformy Morii i nie powinna być bezpośrednio używana w kodzie zewnętrznym.
/// </summary>
		[DataMember]
		protected internal EntityReference<Employees> Employees2RelatedEnd
		{
			get
			{
				IEntityWithRelationships ewr = this;
				return ewr.RelationshipManager.GetRelatedReference<Employees>("FK_Employees_Employees", "Employees");
			}
			set
			{
				if (value != null)
				{
					IEntityWithRelationships ewr = this;
					ewr.RelationshipManager.InitializeRelatedReference<Employees>("FK_Employees_Employees", "Employees", value);
				}
			}
		}
		
		internal object Employees2NoLazyLoading
		{
			get			
			{
				var context = ObjectContext;
				if (context == null || !context.ContextOption_LazyLoadingEnabled)
				{
					return Employees2;
				}
				else
				{
					try
					{
						context.ContextOption_LazyLoadingEnabled = false;
						return Employees2;
					}
					finally
					{
						context.ContextOption_LazyLoadingEnabled = true;
					}
				}
			}
		}
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmRelationshipNavigationProperty("MoxDataModel", "FK_Employees_Employees", "Employees")]
		[XmlIgnore]
		[SoapIgnore]
		[DataMember]
		public Employees Employees2
		{
			get
			{
				return LoadEntityReference(Employees2RelatedEnd);
			}
			
			set
			{
				HandleExplicitAssociationChange(Employees2RelatedEnd, value, "Employees2");
			}
		}
		
/// <summary>
/// Ta własność jest wykorzystywana przez wewnętrzne mechanizmy platformy Morii i nie powinna być bezpośrednio używana w kodzie zewnętrznym.
/// </summary>
		[DataMember]
		protected internal
		EntityCollection<Orders> OrdersRelatedEnd
		{
			get
			{
				IEntityWithRelationships ewr = this;
				return ewr.RelationshipManager.GetRelatedCollection<Orders>("FK_Orders_Employees", "Orders");
			}
			set
			{
				if (value != null)
				{
					IEntityWithRelationships ewr = this;
					ewr.RelationshipManager.InitializeRelatedCollection<Orders>("FK_Orders_Employees", "Orders", value);
				}				
			}
		}
		
		internal object OrdersNoLazyLoading
		{
			get			
			{
				var context = ObjectContext;
				if (context == null || !context.ContextOption_LazyLoadingEnabled)
				{
					return Orders;
				}
				else
				{
					try
					{
						context.ContextOption_LazyLoadingEnabled = false;
						return Orders.ToArray();
					}
					finally
					{
						context.ContextOption_LazyLoadingEnabled = true;
					}
				}
			}
		}
		
		private WrappedEntityCollection<Orders> _wrappedOrders;

		private WrappedEntityCollection<Orders> WrappedOrders
		{
			get
			{
				if (_wrappedOrders == null)
				{
					_wrappedOrders = new WrappedEntityCollection<Orders>(this, "Orders", "Employees");
				}
				_wrappedOrders.UnderlyingEntityCollection = OrdersRelatedEnd;
				return _wrappedOrders;
			}
		}
		

/// <summary></summary>
/// <remarks></remarks>
		[EdmRelationshipNavigationProperty("MoxDataModel", "FK_Orders_Employees", "Orders")]
		[XmlIgnore]
		[SoapIgnore]
		public
		ICollection<Orders> Orders
		{
			get
			{
				return WrappedOrders;
			}
		}						
		#endregion
	}
/// <summary></summary>
/// <remarks></remarks>
	[EdmEntityType(NamespaceName = "MoxDataModel", Name = "Order_Details")]
    [Serializable]
    [DataContract(IsReference = true)]
	[System.CodeDom.Compiler.GeneratedCodeAttribute("InsERT.Mox.DataModeling.DataModelCSharpCodeGenerator", "1.0.0.0")]	
		public 	
	class Order_Details
		: EntityDataObjectBase
	{
		#region type intitialization & runtime type information
		
		private static readonly System.Collections.Generic.Dictionary<string, RelationshipTraversalInfo> relationshipTraversalInfo = new RelationshipTraversalInfo[] 
		{
			FK_Order_Details_OrdersTraversalInfoStore.Order_Details,
			FK_Order_Details_ProductsTraversalInfoStore.Order_Details,
		}.ToDictionary(rti => rti.NavigationPropertyName);
		
/// <summary>
/// Ta własność jest wykorzystywana przez wewnętrzne mechanizmy platformy Morii i nie powinna być bezpośrednio używana w kodzie zewnętrznym.
/// </summary>
        protected override IDictionary<string, RelationshipTraversalInfo> RelationshipTraversalInfo
        {
            get
            {
                return relationshipTraversalInfo;
            }
        }

/// <summary>
/// Ta własność jest wykorzystywana przez wewnętrzne mechanizmy platformy Morii i nie powinna być bezpośrednio używana w kodzie zewnętrznym.
/// </summary>
		protected override bool TryGetInfoForRelatedEndCore(IRelatedEnd relatedEnd, out RelationshipTraversalInfo info)
        {
			var relationshipManager = ((IEntityWithRelationships)this).RelationshipManager;
			if (false)
			{
			}
			else if (relatedEnd == relationshipManager.GetRelatedEnd("FK_Order_Details_Orders", "Orders"))
			{
				info = FK_Order_Details_OrdersTraversalInfoStore.Order_Details;
				return true;
			}
			else if (relatedEnd == relationshipManager.GetRelatedEnd("FK_Order_Details_Products", "Products"))
			{
				info = FK_Order_Details_ProductsTraversalInfoStore.Order_Details;
				return true;
			}
			else
			{            
            	info = null;
				return false;
			}
        }
		
		#endregion
	
		#region instance initialization

/// <summary>
/// Domyślny konstruktor <see cref="T:MoxDataModel.Order_Details" />.
/// </summary>
		public Order_Details()
		{
			ValidateOrderID(_OrderID);
			ValidateProductID(_ProductID);
			ValidateUnitPrice(_UnitPrice);
			ValidateQuantity(_Quantity);
			ValidateDiscount(_Discount);
		}
		
/// <summary>
/// Ta metoda jest wykorzystywana przez wewnętrzne mechanizmy platformy Morii i nie powinna być bezpośrednio używana w kodzie zewnętrznym.
/// </summary>
		protected override bool SubscribeToAssociationChangedEventsCore(string navigationProperty)
		{
			if (base.SubscribeToAssociationChangedEventsCore(navigationProperty))
			{
				if (navigationProperty == "Orders")
				{
					var relatedEnd = OrdersRelatedEnd;
					ValidateOrdersRelatedEnd(relatedEnd);
					relatedEnd.AssociationChanged += HandleOrdersRelatedEndAssociationChanged;
					return false;
				}
				if (navigationProperty == "Products")
				{
					var relatedEnd = ProductsRelatedEnd;
					ValidateProductsRelatedEnd(relatedEnd);
					relatedEnd.AssociationChanged += HandleProductsRelatedEndAssociationChanged;
					return false;
				}
				return true;
			}
			else
			{
				return false;
			}
		}
		#endregion

		#region relationship validation & change notification
		
		private void ValidateOrdersRelatedEnd(EntityReference<Orders> relatedEnd)
		{			
			ValidateRequiredEntityReference(relatedEnd, "Orders");
		}
		
		private void HandleOrdersRelatedEndAssociationChanged(object sender, CollectionChangeEventArgs e)
		{
			DataErrorInfo.RemoveAllErrors("Orders");
			var entityReference = (EntityReference<Orders>)sender;
			ValidateOrdersRelatedEnd(entityReference);
			HandleImplicitAssociationChange(entityReference, e, "Orders");
		}
		
		private void ValidateProductsRelatedEnd(EntityReference<Products> relatedEnd)
		{			
			ValidateRequiredEntityReference(relatedEnd, "Products");
		}
		
		private void HandleProductsRelatedEndAssociationChanged(object sender, CollectionChangeEventArgs e)
		{
			DataErrorInfo.RemoveAllErrors("Products");
			var entityReference = (EntityReference<Products>)sender;
			ValidateProductsRelatedEnd(entityReference);
			HandleImplicitAssociationChange(entityReference, e, "Products");
		}
		
		#endregion
	
		#region scalar property validation
		
		private void ValidateOrderID(System.Int32 value)
		{
		}
		
		private void ValidateProductID(System.Int32 value)
		{
		}
		
		private void ValidateUnitPrice(System.Decimal value)
		{
		}
		
		private void ValidateQuantity(System.Int16 value)
		{
		}
		
		private void ValidateDiscount(System.Single value)
		{
		}
		
		#endregion
	
	
		#region scalar properties
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.Int32 _OrderID = default(System.Int32);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = true, IsNullable = false)]
		[DataMember]
		public System.Int32 OrderID
		{
			get
			{
				return _OrderID;
			}

			internal
			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				DataErrorInfo.RemoveAllErrors("OrderID");
				ValidateOrderID(value);
				ReportPropertyChanging("OrderID");
				_OrderID = value;
				ReportPropertyChanged("OrderID");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.Int32 _ProductID = default(System.Int32);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = true, IsNullable = false)]
		[DataMember]
		public System.Int32 ProductID
		{
			get
			{
				return _ProductID;
			}

			internal
			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				DataErrorInfo.RemoveAllErrors("ProductID");
				ValidateProductID(value);
				ReportPropertyChanging("ProductID");
				_ProductID = value;
				ReportPropertyChanged("ProductID");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.Decimal _UnitPrice = default(System.Decimal);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.Decimal UnitPrice
		{
			get
			{
				return _UnitPrice;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "UnitPrice");
				DataErrorInfo.RemoveAllErrors("UnitPrice");
				ReportScalarPropertyChanging(sink, "UnitPrice", ref value);
				ValidateUnitPrice(value);
				ReportPropertyChanging("UnitPrice");
				_UnitPrice = value;
				ReportPropertyChanged("UnitPrice");
				ReportScalarPropertyChanged(sink, "UnitPrice");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.Int16 _Quantity = default(System.Int16);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.Int16 Quantity
		{
			get
			{
				return _Quantity;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "Quantity");
				DataErrorInfo.RemoveAllErrors("Quantity");
				ReportScalarPropertyChanging(sink, "Quantity", ref value);
				ValidateQuantity(value);
				ReportPropertyChanging("Quantity");
				_Quantity = value;
				ReportPropertyChanged("Quantity");
				ReportScalarPropertyChanged(sink, "Quantity");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.Single _Discount = default(System.Single);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.Single Discount
		{
			get
			{
				return _Discount;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "Discount");
				DataErrorInfo.RemoveAllErrors("Discount");
				ReportScalarPropertyChanging(sink, "Discount", ref value);
				ValidateDiscount(value);
				ReportPropertyChanging("Discount");
				_Discount = value;
				ReportPropertyChanged("Discount");
				ReportScalarPropertyChanged(sink, "Discount");
			}
		}
		
		#endregion
		
		#region complex properties
		
		
		#endregion
		
		#region navigation properties
/// <summary>
/// Ta własność jest wykorzystywana przez wewnętrzne mechanizmy platformy Morii i nie powinna być bezpośrednio używana w kodzie zewnętrznym.
/// </summary>
		[DataMember]
		protected internal EntityReference<Orders> OrdersRelatedEnd
		{
			get
			{
				IEntityWithRelationships ewr = this;
				return ewr.RelationshipManager.GetRelatedReference<Orders>("FK_Order_Details_Orders", "Orders");
			}
			set
			{
				if (value != null)
				{
					IEntityWithRelationships ewr = this;
					ewr.RelationshipManager.InitializeRelatedReference<Orders>("FK_Order_Details_Orders", "Orders", value);
				}
			}
		}
		
		internal object OrdersNoLazyLoading
		{
			get			
			{
				var context = ObjectContext;
				if (context == null || !context.ContextOption_LazyLoadingEnabled)
				{
					return Orders;
				}
				else
				{
					try
					{
						context.ContextOption_LazyLoadingEnabled = false;
						return Orders;
					}
					finally
					{
						context.ContextOption_LazyLoadingEnabled = true;
					}
				}
			}
		}
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmRelationshipNavigationProperty("MoxDataModel", "FK_Order_Details_Orders", "Orders")]
		[XmlIgnore]
		[SoapIgnore]
		[DataMember]
		public Orders Orders
		{
			get
			{
				return LoadEntityReference(OrdersRelatedEnd);
			}
			
			set
			{
				HandleExplicitAssociationChange(OrdersRelatedEnd, value, "Orders");
			}
		}
		
/// <summary>
/// Ta własność jest wykorzystywana przez wewnętrzne mechanizmy platformy Morii i nie powinna być bezpośrednio używana w kodzie zewnętrznym.
/// </summary>
		[DataMember]
		protected internal EntityReference<Products> ProductsRelatedEnd
		{
			get
			{
				IEntityWithRelationships ewr = this;
				return ewr.RelationshipManager.GetRelatedReference<Products>("FK_Order_Details_Products", "Products");
			}
			set
			{
				if (value != null)
				{
					IEntityWithRelationships ewr = this;
					ewr.RelationshipManager.InitializeRelatedReference<Products>("FK_Order_Details_Products", "Products", value);
				}
			}
		}
		
		internal object ProductsNoLazyLoading
		{
			get			
			{
				var context = ObjectContext;
				if (context == null || !context.ContextOption_LazyLoadingEnabled)
				{
					return Products;
				}
				else
				{
					try
					{
						context.ContextOption_LazyLoadingEnabled = false;
						return Products;
					}
					finally
					{
						context.ContextOption_LazyLoadingEnabled = true;
					}
				}
			}
		}
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmRelationshipNavigationProperty("MoxDataModel", "FK_Order_Details_Products", "Products")]
		[XmlIgnore]
		[SoapIgnore]
		[DataMember]
		public Products Products
		{
			get
			{
				return LoadEntityReference(ProductsRelatedEnd);
			}
			
			set
			{
				HandleExplicitAssociationChange(ProductsRelatedEnd, value, "Products");
			}
		}
		
		#endregion
	}
/// <summary></summary>
/// <remarks></remarks>
	[EdmEntityType(NamespaceName = "MoxDataModel", Name = "Orders")]
    [Serializable]
    [DataContract(IsReference = true)]
	[System.CodeDom.Compiler.GeneratedCodeAttribute("InsERT.Mox.DataModeling.DataModelCSharpCodeGenerator", "1.0.0.0")]	
		public 	
	class Orders
		: EntityDataObjectBase
		, IIdentifiable<System.Int32>
	{
		#region type intitialization & runtime type information
		
		private static readonly System.Collections.Generic.Dictionary<string, RelationshipTraversalInfo> relationshipTraversalInfo = new RelationshipTraversalInfo[] 
		{
			FK_Orders_CustomersTraversalInfoStore.Orders,
			FK_Orders_EmployeesTraversalInfoStore.Orders,
			FK_Order_Details_OrdersTraversalInfoStore.Orders,
			FK_Orders_ShippersTraversalInfoStore.Orders,
		}.ToDictionary(rti => rti.NavigationPropertyName);
		
/// <summary>
/// Ta własność jest wykorzystywana przez wewnętrzne mechanizmy platformy Morii i nie powinna być bezpośrednio używana w kodzie zewnętrznym.
/// </summary>
        protected override IDictionary<string, RelationshipTraversalInfo> RelationshipTraversalInfo
        {
            get
            {
                return relationshipTraversalInfo;
            }
        }

/// <summary>
/// Ta własność jest wykorzystywana przez wewnętrzne mechanizmy platformy Morii i nie powinna być bezpośrednio używana w kodzie zewnętrznym.
/// </summary>
		protected override bool TryGetInfoForRelatedEndCore(IRelatedEnd relatedEnd, out RelationshipTraversalInfo info)
        {
			var relationshipManager = ((IEntityWithRelationships)this).RelationshipManager;
			if (false)
			{
			}
			else if (relatedEnd == relationshipManager.GetRelatedEnd("FK_Orders_Customers", "Customers"))
			{
				info = FK_Orders_CustomersTraversalInfoStore.Orders;
				return true;
			}
			else if (relatedEnd == relationshipManager.GetRelatedEnd("FK_Orders_Employees", "Employees"))
			{
				info = FK_Orders_EmployeesTraversalInfoStore.Orders;
				return true;
			}
			else if (relatedEnd == relationshipManager.GetRelatedEnd("FK_Order_Details_Orders", "Order_Details"))
			{
				info = FK_Order_Details_OrdersTraversalInfoStore.Orders;
				return true;
			}
			else if (relatedEnd == relationshipManager.GetRelatedEnd("FK_Orders_Shippers", "Shippers"))
			{
				info = FK_Orders_ShippersTraversalInfoStore.Orders;
				return true;
			}
			else
			{            
            	info = null;
				return false;
			}
        }
		
		#endregion
	
		#region instance initialization

/// <summary>
/// Domyślny konstruktor <see cref="T:MoxDataModel.Orders" />.
/// </summary>
		public Orders()
		{
			ValidateOrderID(_OrderID);
			ValidateCustomerID(_CustomerID);
			ValidateEmployeeID(_EmployeeID);
			ValidateOrderDate(_OrderDate);
			ValidateRequiredDate(_RequiredDate);
			ValidateShippedDate(_ShippedDate);
			ValidateShipVia(_ShipVia);
			ValidateFreight(_Freight);
			ValidateShipName(_ShipName);
			ValidateShipAddress(_ShipAddress);
			ValidateShipCity(_ShipCity);
			ValidateShipRegion(_ShipRegion);
			ValidateShipPostalCode(_ShipPostalCode);
			ValidateShipCountry(_ShipCountry);
		}
		
/// <summary>
/// Ta metoda jest wykorzystywana przez wewnętrzne mechanizmy platformy Morii i nie powinna być bezpośrednio używana w kodzie zewnętrznym.
/// </summary>
		protected override bool SubscribeToAssociationChangedEventsCore(string navigationProperty)
		{
			if (base.SubscribeToAssociationChangedEventsCore(navigationProperty))
			{
				if (navigationProperty == "Customers")
				{
					var relatedEnd = CustomersRelatedEnd;
					ValidateCustomersRelatedEnd(relatedEnd);
					relatedEnd.AssociationChanged += HandleCustomersRelatedEndAssociationChanged;
					return false;
				}
				if (navigationProperty == "Employees")
				{
					var relatedEnd = EmployeesRelatedEnd;
					ValidateEmployeesRelatedEnd(relatedEnd);
					relatedEnd.AssociationChanged += HandleEmployeesRelatedEndAssociationChanged;
					return false;
				}
				if (navigationProperty == "Order_Details")
				{
					var relatedEnd = Order_DetailsRelatedEnd;
					ValidateOrder_DetailsRelatedEnd(relatedEnd);
					relatedEnd.AssociationChanged += HandleOrder_DetailsRelatedEndAssociationChanged;
					return false;
				}
				if (navigationProperty == "Shippers")
				{
					var relatedEnd = ShippersRelatedEnd;
					ValidateShippersRelatedEnd(relatedEnd);
					relatedEnd.AssociationChanged += HandleShippersRelatedEndAssociationChanged;
					return false;
				}
				return true;
			}
			else
			{
				return false;
			}
		}
		#endregion

		#region relationship validation & change notification
		
		private void ValidateCustomersRelatedEnd(EntityReference<Customers> relatedEnd)
		{			
			ValidateRequiredEntityReference(relatedEnd, "Customers");
		}
		
		private void HandleCustomersRelatedEndAssociationChanged(object sender, CollectionChangeEventArgs e)
		{
			DataErrorInfo.RemoveAllErrors("Customers");
			var entityReference = (EntityReference<Customers>)sender;
			ValidateCustomersRelatedEnd(entityReference);
			HandleImplicitAssociationChange(entityReference, e, "Customers");
		}
		
		private void ValidateEmployeesRelatedEnd(EntityReference<Employees> relatedEnd)
		{			
		}
		
		private void HandleEmployeesRelatedEndAssociationChanged(object sender, CollectionChangeEventArgs e)
		{
			DataErrorInfo.RemoveAllErrors("Employees");
			var entityReference = (EntityReference<Employees>)sender;
			ValidateEmployeesRelatedEnd(entityReference);
			HandleImplicitAssociationChange(entityReference, e, "Employees");
		}
		
		private void ValidateOrder_DetailsRelatedEnd(EntityCollection<Order_Details> relatedEnd)
		{
		}
		
		private void HandleOrder_DetailsRelatedEndAssociationChanged(object sender, CollectionChangeEventArgs e)
		{
			DataErrorInfo.RemoveAllErrors("Order_Details");
			var entityCollection = (EntityCollection<Order_Details>)sender;
			ValidateOrder_DetailsRelatedEnd(entityCollection);
			HandleImplicitAssociationChange(entityCollection, e, "Order_Details");			
		}
		
		private void ValidateShippersRelatedEnd(EntityReference<Shippers> relatedEnd)
		{			
		}
		
		private void HandleShippersRelatedEndAssociationChanged(object sender, CollectionChangeEventArgs e)
		{
			DataErrorInfo.RemoveAllErrors("Shippers");
			var entityReference = (EntityReference<Shippers>)sender;
			ValidateShippersRelatedEnd(entityReference);
			HandleImplicitAssociationChange(entityReference, e, "Shippers");
		}
		
		#endregion
	
		#region scalar property validation
		
		private void ValidateOrderID(System.Int32 value)
		{
		}
		
		private void ValidateCustomerID(System.String value)
		{
			if (value == null)
			{
				DataErrorInfo.AddError(new MemberIsNullError(), "CustomerID");
			}
			if (value != null && value.Length != 5)
			{
				DataErrorInfo.AddError(new StringLengthError(5, 5), "CustomerID");
			}
		}
		
		private void ValidateEmployeeID(System.Int32? value)
		{
		}
		
		private void ValidateOrderDate(System.DateTime value)
		{
		}
		
		private void ValidateRequiredDate(System.DateTime value)
		{
		}
		
		private void ValidateShippedDate(System.DateTime value)
		{
		}
		
		private void ValidateShipVia(System.Int32? value)
		{
		}
		
		private void ValidateFreight(System.Decimal value)
		{
		}
		
		private void ValidateShipName(System.String value)
		{
			if (value == null)
			{
				DataErrorInfo.AddError(new MemberIsNullError(), "ShipName");
			}
			if (value != null && value.Length > 40)
			{
				DataErrorInfo.AddError(new StringLengthError(40, false), "ShipName");
			}
		}
		
		private void ValidateShipAddress(System.String value)
		{
			if (value == null)
			{
				DataErrorInfo.AddError(new MemberIsNullError(), "ShipAddress");
			}
			if (value != null && value.Length > 60)
			{
				DataErrorInfo.AddError(new StringLengthError(60, false), "ShipAddress");
			}
		}
		
		private void ValidateShipCity(System.String value)
		{
			if (value == null)
			{
				DataErrorInfo.AddError(new MemberIsNullError(), "ShipCity");
			}
			if (value != null && value.Length > 15)
			{
				DataErrorInfo.AddError(new StringLengthError(15, false), "ShipCity");
			}
		}
		
		private void ValidateShipRegion(System.String value)
		{
			if (value == null)
			{
				DataErrorInfo.AddError(new MemberIsNullError(), "ShipRegion");
			}
			if (value != null && value.Length > 15)
			{
				DataErrorInfo.AddError(new StringLengthError(15, false), "ShipRegion");
			}
		}
		
		private void ValidateShipPostalCode(System.String value)
		{
			if (value == null)
			{
				DataErrorInfo.AddError(new MemberIsNullError(), "ShipPostalCode");
			}
			if (value != null && value.Length > 10)
			{
				DataErrorInfo.AddError(new StringLengthError(10, false), "ShipPostalCode");
			}
		}
		
		private void ValidateShipCountry(System.String value)
		{
			if (value == null)
			{
				DataErrorInfo.AddError(new MemberIsNullError(), "ShipCountry");
			}
			if (value != null && value.Length > 15)
			{
				DataErrorInfo.AddError(new StringLengthError(15, false), "ShipCountry");
			}
		}
		
		#endregion
	
		#region explicit identifier accessor
		
		System.Int32 IIdentifiable<System.Int32>.Id
		{
			get
			{
				return OrderID;
			}			
		}
		
		object IIdentifiable.Id
		{
			get
			{
				return OrderID;
			}
		}
		
		Type IIdentifiable.IdType
		{
			get
			{
				return typeof(System.Int32);
			}
		}
		
		#endregion
	
		#region scalar properties
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.Int32 _OrderID = default(System.Int32);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = true, IsNullable = false)]
		[DataMember]
		public System.Int32 OrderID
		{
			get
			{
				return _OrderID;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				DataErrorInfo.RemoveAllErrors("OrderID");
				ReportScalarPropertyChanging(sink, "OrderID", ref value);
				ValidateOrderID(value);
				ReportPropertyChanging("OrderID");
				_OrderID = value;
				ReportPropertyChanged("OrderID");
				ReportScalarPropertyChanged(sink, "OrderID");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.String _CustomerID = default(System.String);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.String CustomerID
		{
			get
			{
				return _CustomerID;
			}

			internal
			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				DataErrorInfo.RemoveAllErrors("CustomerID");
				ValidateCustomerID(value);
				ReportPropertyChanging("CustomerID");
				_CustomerID = value;
				ReportPropertyChanged("CustomerID");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.Int32? _EmployeeID = default(System.Int32?);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = true)]
		[DataMember]
		public System.Int32? EmployeeID
		{
			get
			{
				return _EmployeeID;
			}

			internal
			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				DataErrorInfo.RemoveAllErrors("EmployeeID");
				ValidateEmployeeID(value);
				ReportPropertyChanging("EmployeeID");
				_EmployeeID = value;
				ReportPropertyChanged("EmployeeID");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.DateTime _OrderDate = default(System.DateTime);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.DateTime OrderDate
		{
			get
			{
				return _OrderDate;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "OrderDate");
				DataErrorInfo.RemoveAllErrors("OrderDate");
				ReportScalarPropertyChanging(sink, "OrderDate", ref value);
				ValidateOrderDate(value);
				ReportPropertyChanging("OrderDate");
				_OrderDate = value;
				ReportPropertyChanged("OrderDate");
				ReportScalarPropertyChanged(sink, "OrderDate");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.DateTime _RequiredDate = default(System.DateTime);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.DateTime RequiredDate
		{
			get
			{
				return _RequiredDate;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "RequiredDate");
				DataErrorInfo.RemoveAllErrors("RequiredDate");
				ReportScalarPropertyChanging(sink, "RequiredDate", ref value);
				ValidateRequiredDate(value);
				ReportPropertyChanging("RequiredDate");
				_RequiredDate = value;
				ReportPropertyChanged("RequiredDate");
				ReportScalarPropertyChanged(sink, "RequiredDate");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.DateTime _ShippedDate = default(System.DateTime);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.DateTime ShippedDate
		{
			get
			{
				return _ShippedDate;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "ShippedDate");
				DataErrorInfo.RemoveAllErrors("ShippedDate");
				ReportScalarPropertyChanging(sink, "ShippedDate", ref value);
				ValidateShippedDate(value);
				ReportPropertyChanging("ShippedDate");
				_ShippedDate = value;
				ReportPropertyChanged("ShippedDate");
				ReportScalarPropertyChanged(sink, "ShippedDate");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.Int32? _ShipVia = default(System.Int32?);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = true)]
		[DataMember]
		public System.Int32? ShipVia
		{
			get
			{
				return _ShipVia;
			}

			internal
			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				DataErrorInfo.RemoveAllErrors("ShipVia");
				ValidateShipVia(value);
				ReportPropertyChanging("ShipVia");
				_ShipVia = value;
				ReportPropertyChanged("ShipVia");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.Decimal _Freight = default(System.Decimal);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.Decimal Freight
		{
			get
			{
				return _Freight;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "Freight");
				DataErrorInfo.RemoveAllErrors("Freight");
				ReportScalarPropertyChanging(sink, "Freight", ref value);
				ValidateFreight(value);
				ReportPropertyChanging("Freight");
				_Freight = value;
				ReportPropertyChanged("Freight");
				ReportScalarPropertyChanged(sink, "Freight");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.String _ShipName = default(System.String);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.String ShipName
		{
			get
			{
				return _ShipName;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "ShipName");
				DataErrorInfo.RemoveAllErrors("ShipName");
				ReportScalarPropertyChanging(sink, "ShipName", ref value);
				ValidateShipName(value);
				ReportPropertyChanging("ShipName");
				_ShipName = value;
				ReportPropertyChanged("ShipName");
				ReportScalarPropertyChanged(sink, "ShipName");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.String _ShipAddress = default(System.String);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.String ShipAddress
		{
			get
			{
				return _ShipAddress;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "ShipAddress");
				DataErrorInfo.RemoveAllErrors("ShipAddress");
				ReportScalarPropertyChanging(sink, "ShipAddress", ref value);
				ValidateShipAddress(value);
				ReportPropertyChanging("ShipAddress");
				_ShipAddress = value;
				ReportPropertyChanged("ShipAddress");
				ReportScalarPropertyChanged(sink, "ShipAddress");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.String _ShipCity = default(System.String);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.String ShipCity
		{
			get
			{
				return _ShipCity;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "ShipCity");
				DataErrorInfo.RemoveAllErrors("ShipCity");
				ReportScalarPropertyChanging(sink, "ShipCity", ref value);
				ValidateShipCity(value);
				ReportPropertyChanging("ShipCity");
				_ShipCity = value;
				ReportPropertyChanged("ShipCity");
				ReportScalarPropertyChanged(sink, "ShipCity");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.String _ShipRegion = default(System.String);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.String ShipRegion
		{
			get
			{
				return _ShipRegion;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "ShipRegion");
				DataErrorInfo.RemoveAllErrors("ShipRegion");
				ReportScalarPropertyChanging(sink, "ShipRegion", ref value);
				ValidateShipRegion(value);
				ReportPropertyChanging("ShipRegion");
				_ShipRegion = value;
				ReportPropertyChanged("ShipRegion");
				ReportScalarPropertyChanged(sink, "ShipRegion");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.String _ShipPostalCode = default(System.String);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.String ShipPostalCode
		{
			get
			{
				return _ShipPostalCode;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "ShipPostalCode");
				DataErrorInfo.RemoveAllErrors("ShipPostalCode");
				ReportScalarPropertyChanging(sink, "ShipPostalCode", ref value);
				ValidateShipPostalCode(value);
				ReportPropertyChanging("ShipPostalCode");
				_ShipPostalCode = value;
				ReportPropertyChanged("ShipPostalCode");
				ReportScalarPropertyChanged(sink, "ShipPostalCode");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.String _ShipCountry = default(System.String);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.String ShipCountry
		{
			get
			{
				return _ShipCountry;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "ShipCountry");
				DataErrorInfo.RemoveAllErrors("ShipCountry");
				ReportScalarPropertyChanging(sink, "ShipCountry", ref value);
				ValidateShipCountry(value);
				ReportPropertyChanging("ShipCountry");
				_ShipCountry = value;
				ReportPropertyChanged("ShipCountry");
				ReportScalarPropertyChanged(sink, "ShipCountry");
			}
		}
		
		#endregion
		
		#region complex properties
		
		
		#endregion
		
		#region navigation properties
/// <summary>
/// Ta własność jest wykorzystywana przez wewnętrzne mechanizmy platformy Morii i nie powinna być bezpośrednio używana w kodzie zewnętrznym.
/// </summary>
		[DataMember]
		protected internal EntityReference<Customers> CustomersRelatedEnd
		{
			get
			{
				IEntityWithRelationships ewr = this;
				return ewr.RelationshipManager.GetRelatedReference<Customers>("FK_Orders_Customers", "Customers");
			}
			set
			{
				if (value != null)
				{
					IEntityWithRelationships ewr = this;
					ewr.RelationshipManager.InitializeRelatedReference<Customers>("FK_Orders_Customers", "Customers", value);
				}
			}
		}
		
		internal object CustomersNoLazyLoading
		{
			get			
			{
				var context = ObjectContext;
				if (context == null || !context.ContextOption_LazyLoadingEnabled)
				{
					return Customers;
				}
				else
				{
					try
					{
						context.ContextOption_LazyLoadingEnabled = false;
						return Customers;
					}
					finally
					{
						context.ContextOption_LazyLoadingEnabled = true;
					}
				}
			}
		}
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmRelationshipNavigationProperty("MoxDataModel", "FK_Orders_Customers", "Customers")]
		[XmlIgnore]
		[SoapIgnore]
		[DataMember]
		public Customers Customers
		{
			get
			{
				return LoadEntityReference(CustomersRelatedEnd);
			}
			
			set
			{
				HandleExplicitAssociationChange(CustomersRelatedEnd, value, "Customers");
			}
		}
		
/// <summary>
/// Ta własność jest wykorzystywana przez wewnętrzne mechanizmy platformy Morii i nie powinna być bezpośrednio używana w kodzie zewnętrznym.
/// </summary>
		[DataMember]
		protected internal EntityReference<Employees> EmployeesRelatedEnd
		{
			get
			{
				IEntityWithRelationships ewr = this;
				return ewr.RelationshipManager.GetRelatedReference<Employees>("FK_Orders_Employees", "Employees");
			}
			set
			{
				if (value != null)
				{
					IEntityWithRelationships ewr = this;
					ewr.RelationshipManager.InitializeRelatedReference<Employees>("FK_Orders_Employees", "Employees", value);
				}
			}
		}
		
		internal object EmployeesNoLazyLoading
		{
			get			
			{
				var context = ObjectContext;
				if (context == null || !context.ContextOption_LazyLoadingEnabled)
				{
					return Employees;
				}
				else
				{
					try
					{
						context.ContextOption_LazyLoadingEnabled = false;
						return Employees;
					}
					finally
					{
						context.ContextOption_LazyLoadingEnabled = true;
					}
				}
			}
		}
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmRelationshipNavigationProperty("MoxDataModel", "FK_Orders_Employees", "Employees")]
		[XmlIgnore]
		[SoapIgnore]
		[DataMember]
		public Employees Employees
		{
			get
			{
				return LoadEntityReference(EmployeesRelatedEnd);
			}
			
			set
			{
				HandleExplicitAssociationChange(EmployeesRelatedEnd, value, "Employees");
			}
		}
		
/// <summary>
/// Ta własność jest wykorzystywana przez wewnętrzne mechanizmy platformy Morii i nie powinna być bezpośrednio używana w kodzie zewnętrznym.
/// </summary>
		[DataMember]
		protected internal
		EntityCollection<Order_Details> Order_DetailsRelatedEnd
		{
			get
			{
				IEntityWithRelationships ewr = this;
				return ewr.RelationshipManager.GetRelatedCollection<Order_Details>("FK_Order_Details_Orders", "Order_Details");
			}
			set
			{
				if (value != null)
				{
					IEntityWithRelationships ewr = this;
					ewr.RelationshipManager.InitializeRelatedCollection<Order_Details>("FK_Order_Details_Orders", "Order_Details", value);
				}				
			}
		}
		
		internal object Order_DetailsNoLazyLoading
		{
			get			
			{
				var context = ObjectContext;
				if (context == null || !context.ContextOption_LazyLoadingEnabled)
				{
					return Order_Details;
				}
				else
				{
					try
					{
						context.ContextOption_LazyLoadingEnabled = false;
						return Order_Details.ToArray();
					}
					finally
					{
						context.ContextOption_LazyLoadingEnabled = true;
					}
				}
			}
		}
		
		private WrappedEntityCollection<Order_Details> _wrappedOrder_Details;

		private WrappedEntityCollection<Order_Details> WrappedOrder_Details
		{
			get
			{
				if (_wrappedOrder_Details == null)
				{
					_wrappedOrder_Details = new WrappedEntityCollection<Order_Details>(this, "Order_Details", "Orders");
				}
				_wrappedOrder_Details.UnderlyingEntityCollection = Order_DetailsRelatedEnd;
				return _wrappedOrder_Details;
			}
		}
		

/// <summary></summary>
/// <remarks></remarks>
		[EdmRelationshipNavigationProperty("MoxDataModel", "FK_Order_Details_Orders", "Order_Details")]
		[XmlIgnore]
		[SoapIgnore]
		public
		ICollection<Order_Details> Order_Details
		{
			get
			{
				return WrappedOrder_Details;
			}
		}						
/// <summary>
/// Ta własność jest wykorzystywana przez wewnętrzne mechanizmy platformy Morii i nie powinna być bezpośrednio używana w kodzie zewnętrznym.
/// </summary>
		[DataMember]
		protected internal EntityReference<Shippers> ShippersRelatedEnd
		{
			get
			{
				IEntityWithRelationships ewr = this;
				return ewr.RelationshipManager.GetRelatedReference<Shippers>("FK_Orders_Shippers", "Shippers");
			}
			set
			{
				if (value != null)
				{
					IEntityWithRelationships ewr = this;
					ewr.RelationshipManager.InitializeRelatedReference<Shippers>("FK_Orders_Shippers", "Shippers", value);
				}
			}
		}
		
		internal object ShippersNoLazyLoading
		{
			get			
			{
				var context = ObjectContext;
				if (context == null || !context.ContextOption_LazyLoadingEnabled)
				{
					return Shippers;
				}
				else
				{
					try
					{
						context.ContextOption_LazyLoadingEnabled = false;
						return Shippers;
					}
					finally
					{
						context.ContextOption_LazyLoadingEnabled = true;
					}
				}
			}
		}
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmRelationshipNavigationProperty("MoxDataModel", "FK_Orders_Shippers", "Shippers")]
		[XmlIgnore]
		[SoapIgnore]
		[DataMember]
		public Shippers Shippers
		{
			get
			{
				return LoadEntityReference(ShippersRelatedEnd);
			}
			
			set
			{
				HandleExplicitAssociationChange(ShippersRelatedEnd, value, "Shippers");
			}
		}
		
		#endregion
	}
/// <summary></summary>
/// <remarks></remarks>
	[EdmEntityType(NamespaceName = "MoxDataModel", Name = "Products")]
    [Serializable]
    [DataContract(IsReference = true)]
	[System.CodeDom.Compiler.GeneratedCodeAttribute("InsERT.Mox.DataModeling.DataModelCSharpCodeGenerator", "1.0.0.0")]	
		public 	
	class Products
		: EntityDataObjectBase
		, IIdentifiable<System.Int32>
	{
		#region type intitialization & runtime type information
		
		private static readonly System.Collections.Generic.Dictionary<string, RelationshipTraversalInfo> relationshipTraversalInfo = new RelationshipTraversalInfo[] 
		{
			FK_Products_CategoriesTraversalInfoStore.Products,
			FK_Order_Details_ProductsTraversalInfoStore.Products,
			FK_Products_SuppliersTraversalInfoStore.Products,
		}.ToDictionary(rti => rti.NavigationPropertyName);
		
/// <summary>
/// Ta własność jest wykorzystywana przez wewnętrzne mechanizmy platformy Morii i nie powinna być bezpośrednio używana w kodzie zewnętrznym.
/// </summary>
        protected override IDictionary<string, RelationshipTraversalInfo> RelationshipTraversalInfo
        {
            get
            {
                return relationshipTraversalInfo;
            }
        }

/// <summary>
/// Ta własność jest wykorzystywana przez wewnętrzne mechanizmy platformy Morii i nie powinna być bezpośrednio używana w kodzie zewnętrznym.
/// </summary>
		protected override bool TryGetInfoForRelatedEndCore(IRelatedEnd relatedEnd, out RelationshipTraversalInfo info)
        {
			var relationshipManager = ((IEntityWithRelationships)this).RelationshipManager;
			if (false)
			{
			}
			else if (relatedEnd == relationshipManager.GetRelatedEnd("FK_Products_Categories", "Categories"))
			{
				info = FK_Products_CategoriesTraversalInfoStore.Products;
				return true;
			}
			else if (relatedEnd == relationshipManager.GetRelatedEnd("FK_Order_Details_Products", "Order_Details"))
			{
				info = FK_Order_Details_ProductsTraversalInfoStore.Products;
				return true;
			}
			else if (relatedEnd == relationshipManager.GetRelatedEnd("FK_Products_Suppliers", "Suppliers"))
			{
				info = FK_Products_SuppliersTraversalInfoStore.Products;
				return true;
			}
			else
			{            
            	info = null;
				return false;
			}
        }
		
		#endregion
	
		#region instance initialization

/// <summary>
/// Domyślny konstruktor <see cref="T:MoxDataModel.Products" />.
/// </summary>
		public Products()
		{
			ValidateProductID(_ProductID);
			ValidateProductName(_ProductName);
			ValidateSupplierID(_SupplierID);
			ValidateCategoryID(_CategoryID);
			ValidateQuantityPerUnit(_QuantityPerUnit);
			ValidateUnitPrice(_UnitPrice);
			ValidateUnitsInStock(_UnitsInStock);
			ValidateUnitsOnOrder(_UnitsOnOrder);
			ValidateReorderLevel(_ReorderLevel);
			ValidateDiscontinued(_Discontinued);
		}
		
/// <summary>
/// Ta metoda jest wykorzystywana przez wewnętrzne mechanizmy platformy Morii i nie powinna być bezpośrednio używana w kodzie zewnętrznym.
/// </summary>
		protected override bool SubscribeToAssociationChangedEventsCore(string navigationProperty)
		{
			if (base.SubscribeToAssociationChangedEventsCore(navigationProperty))
			{
				if (navigationProperty == "Categories")
				{
					var relatedEnd = CategoriesRelatedEnd;
					ValidateCategoriesRelatedEnd(relatedEnd);
					relatedEnd.AssociationChanged += HandleCategoriesRelatedEndAssociationChanged;
					return false;
				}
				if (navigationProperty == "Order_Details")
				{
					var relatedEnd = Order_DetailsRelatedEnd;
					ValidateOrder_DetailsRelatedEnd(relatedEnd);
					relatedEnd.AssociationChanged += HandleOrder_DetailsRelatedEndAssociationChanged;
					return false;
				}
				if (navigationProperty == "Suppliers")
				{
					var relatedEnd = SuppliersRelatedEnd;
					ValidateSuppliersRelatedEnd(relatedEnd);
					relatedEnd.AssociationChanged += HandleSuppliersRelatedEndAssociationChanged;
					return false;
				}
				return true;
			}
			else
			{
				return false;
			}
		}
		#endregion

		#region relationship validation & change notification
		
		private void ValidateCategoriesRelatedEnd(EntityReference<Categories> relatedEnd)
		{			
		}
		
		private void HandleCategoriesRelatedEndAssociationChanged(object sender, CollectionChangeEventArgs e)
		{
			DataErrorInfo.RemoveAllErrors("Categories");
			var entityReference = (EntityReference<Categories>)sender;
			ValidateCategoriesRelatedEnd(entityReference);
			HandleImplicitAssociationChange(entityReference, e, "Categories");
		}
		
		private void ValidateOrder_DetailsRelatedEnd(EntityCollection<Order_Details> relatedEnd)
		{
		}
		
		private void HandleOrder_DetailsRelatedEndAssociationChanged(object sender, CollectionChangeEventArgs e)
		{
			DataErrorInfo.RemoveAllErrors("Order_Details");
			var entityCollection = (EntityCollection<Order_Details>)sender;
			ValidateOrder_DetailsRelatedEnd(entityCollection);
			HandleImplicitAssociationChange(entityCollection, e, "Order_Details");			
		}
		
		private void ValidateSuppliersRelatedEnd(EntityReference<Suppliers> relatedEnd)
		{			
		}
		
		private void HandleSuppliersRelatedEndAssociationChanged(object sender, CollectionChangeEventArgs e)
		{
			DataErrorInfo.RemoveAllErrors("Suppliers");
			var entityReference = (EntityReference<Suppliers>)sender;
			ValidateSuppliersRelatedEnd(entityReference);
			HandleImplicitAssociationChange(entityReference, e, "Suppliers");
		}
		
		#endregion
	
		#region scalar property validation
		
		private void ValidateProductID(System.Int32 value)
		{
		}
		
		private void ValidateProductName(System.String value)
		{
			if (value == null)
			{
				DataErrorInfo.AddError(new MemberIsNullError(), "ProductName");
			}
			if (value != null && value.Length > 40)
			{
				DataErrorInfo.AddError(new StringLengthError(40, false), "ProductName");
			}
		}
		
		private void ValidateSupplierID(System.Int32? value)
		{
		}
		
		private void ValidateCategoryID(System.Int32? value)
		{
		}
		
		private void ValidateQuantityPerUnit(System.String value)
		{
			if (value == null)
			{
				DataErrorInfo.AddError(new MemberIsNullError(), "QuantityPerUnit");
			}
			if (value != null && value.Length > 20)
			{
				DataErrorInfo.AddError(new StringLengthError(20, false), "QuantityPerUnit");
			}
		}
		
		private void ValidateUnitPrice(System.Decimal value)
		{
		}
		
		private void ValidateUnitsInStock(System.Int16 value)
		{
		}
		
		private void ValidateUnitsOnOrder(System.Int16 value)
		{
		}
		
		private void ValidateReorderLevel(System.Int16 value)
		{
		}
		
		private void ValidateDiscontinued(System.Boolean value)
		{
		}
		
		#endregion
	
		#region explicit identifier accessor
		
		System.Int32 IIdentifiable<System.Int32>.Id
		{
			get
			{
				return ProductID;
			}			
		}
		
		object IIdentifiable.Id
		{
			get
			{
				return ProductID;
			}
		}
		
		Type IIdentifiable.IdType
		{
			get
			{
				return typeof(System.Int32);
			}
		}
		
		#endregion
	
		#region scalar properties
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.Int32 _ProductID = default(System.Int32);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = true, IsNullable = false)]
		[DataMember]
		public System.Int32 ProductID
		{
			get
			{
				return _ProductID;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				DataErrorInfo.RemoveAllErrors("ProductID");
				ReportScalarPropertyChanging(sink, "ProductID", ref value);
				ValidateProductID(value);
				ReportPropertyChanging("ProductID");
				_ProductID = value;
				ReportPropertyChanged("ProductID");
				ReportScalarPropertyChanged(sink, "ProductID");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.String _ProductName = default(System.String);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.String ProductName
		{
			get
			{
				return _ProductName;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "ProductName");
				DataErrorInfo.RemoveAllErrors("ProductName");
				ReportScalarPropertyChanging(sink, "ProductName", ref value);
				ValidateProductName(value);
				ReportPropertyChanging("ProductName");
				_ProductName = value;
				ReportPropertyChanged("ProductName");
				ReportScalarPropertyChanged(sink, "ProductName");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.Int32? _SupplierID = default(System.Int32?);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = true)]
		[DataMember]
		public System.Int32? SupplierID
		{
			get
			{
				return _SupplierID;
			}

			internal
			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				DataErrorInfo.RemoveAllErrors("SupplierID");
				ValidateSupplierID(value);
				ReportPropertyChanging("SupplierID");
				_SupplierID = value;
				ReportPropertyChanged("SupplierID");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.Int32? _CategoryID = default(System.Int32?);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = true)]
		[DataMember]
		public System.Int32? CategoryID
		{
			get
			{
				return _CategoryID;
			}

			internal
			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				DataErrorInfo.RemoveAllErrors("CategoryID");
				ValidateCategoryID(value);
				ReportPropertyChanging("CategoryID");
				_CategoryID = value;
				ReportPropertyChanged("CategoryID");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.String _QuantityPerUnit = default(System.String);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.String QuantityPerUnit
		{
			get
			{
				return _QuantityPerUnit;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "QuantityPerUnit");
				DataErrorInfo.RemoveAllErrors("QuantityPerUnit");
				ReportScalarPropertyChanging(sink, "QuantityPerUnit", ref value);
				ValidateQuantityPerUnit(value);
				ReportPropertyChanging("QuantityPerUnit");
				_QuantityPerUnit = value;
				ReportPropertyChanged("QuantityPerUnit");
				ReportScalarPropertyChanged(sink, "QuantityPerUnit");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.Decimal _UnitPrice = default(System.Decimal);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.Decimal UnitPrice
		{
			get
			{
				return _UnitPrice;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "UnitPrice");
				DataErrorInfo.RemoveAllErrors("UnitPrice");
				ReportScalarPropertyChanging(sink, "UnitPrice", ref value);
				ValidateUnitPrice(value);
				ReportPropertyChanging("UnitPrice");
				_UnitPrice = value;
				ReportPropertyChanged("UnitPrice");
				ReportScalarPropertyChanged(sink, "UnitPrice");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.Int16 _UnitsInStock = default(System.Int16);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.Int16 UnitsInStock
		{
			get
			{
				return _UnitsInStock;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "UnitsInStock");
				DataErrorInfo.RemoveAllErrors("UnitsInStock");
				ReportScalarPropertyChanging(sink, "UnitsInStock", ref value);
				ValidateUnitsInStock(value);
				ReportPropertyChanging("UnitsInStock");
				_UnitsInStock = value;
				ReportPropertyChanged("UnitsInStock");
				ReportScalarPropertyChanged(sink, "UnitsInStock");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.Int16 _UnitsOnOrder = default(System.Int16);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.Int16 UnitsOnOrder
		{
			get
			{
				return _UnitsOnOrder;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "UnitsOnOrder");
				DataErrorInfo.RemoveAllErrors("UnitsOnOrder");
				ReportScalarPropertyChanging(sink, "UnitsOnOrder", ref value);
				ValidateUnitsOnOrder(value);
				ReportPropertyChanging("UnitsOnOrder");
				_UnitsOnOrder = value;
				ReportPropertyChanged("UnitsOnOrder");
				ReportScalarPropertyChanged(sink, "UnitsOnOrder");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.Int16 _ReorderLevel = default(System.Int16);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.Int16 ReorderLevel
		{
			get
			{
				return _ReorderLevel;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "ReorderLevel");
				DataErrorInfo.RemoveAllErrors("ReorderLevel");
				ReportScalarPropertyChanging(sink, "ReorderLevel", ref value);
				ValidateReorderLevel(value);
				ReportPropertyChanging("ReorderLevel");
				_ReorderLevel = value;
				ReportPropertyChanged("ReorderLevel");
				ReportScalarPropertyChanged(sink, "ReorderLevel");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.Boolean _Discontinued = default(System.Boolean);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.Boolean Discontinued
		{
			get
			{
				return _Discontinued;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "Discontinued");
				DataErrorInfo.RemoveAllErrors("Discontinued");
				ReportScalarPropertyChanging(sink, "Discontinued", ref value);
				ValidateDiscontinued(value);
				ReportPropertyChanging("Discontinued");
				_Discontinued = value;
				ReportPropertyChanged("Discontinued");
				ReportScalarPropertyChanged(sink, "Discontinued");
			}
		}
		
		#endregion
		
		#region complex properties
		
		
		#endregion
		
		#region navigation properties
/// <summary>
/// Ta własność jest wykorzystywana przez wewnętrzne mechanizmy platformy Morii i nie powinna być bezpośrednio używana w kodzie zewnętrznym.
/// </summary>
		[DataMember]
		protected internal EntityReference<Categories> CategoriesRelatedEnd
		{
			get
			{
				IEntityWithRelationships ewr = this;
				return ewr.RelationshipManager.GetRelatedReference<Categories>("FK_Products_Categories", "Categories");
			}
			set
			{
				if (value != null)
				{
					IEntityWithRelationships ewr = this;
					ewr.RelationshipManager.InitializeRelatedReference<Categories>("FK_Products_Categories", "Categories", value);
				}
			}
		}
		
		internal object CategoriesNoLazyLoading
		{
			get			
			{
				var context = ObjectContext;
				if (context == null || !context.ContextOption_LazyLoadingEnabled)
				{
					return Categories;
				}
				else
				{
					try
					{
						context.ContextOption_LazyLoadingEnabled = false;
						return Categories;
					}
					finally
					{
						context.ContextOption_LazyLoadingEnabled = true;
					}
				}
			}
		}
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmRelationshipNavigationProperty("MoxDataModel", "FK_Products_Categories", "Categories")]
		[XmlIgnore]
		[SoapIgnore]
		[DataMember]
		public Categories Categories
		{
			get
			{
				return LoadEntityReference(CategoriesRelatedEnd);
			}
			
			set
			{
				HandleExplicitAssociationChange(CategoriesRelatedEnd, value, "Categories");
			}
		}
		
/// <summary>
/// Ta własność jest wykorzystywana przez wewnętrzne mechanizmy platformy Morii i nie powinna być bezpośrednio używana w kodzie zewnętrznym.
/// </summary>
		[DataMember]
		protected internal
		EntityCollection<Order_Details> Order_DetailsRelatedEnd
		{
			get
			{
				IEntityWithRelationships ewr = this;
				return ewr.RelationshipManager.GetRelatedCollection<Order_Details>("FK_Order_Details_Products", "Order_Details");
			}
			set
			{
				if (value != null)
				{
					IEntityWithRelationships ewr = this;
					ewr.RelationshipManager.InitializeRelatedCollection<Order_Details>("FK_Order_Details_Products", "Order_Details", value);
				}				
			}
		}
		
		internal object Order_DetailsNoLazyLoading
		{
			get			
			{
				var context = ObjectContext;
				if (context == null || !context.ContextOption_LazyLoadingEnabled)
				{
					return Order_Details;
				}
				else
				{
					try
					{
						context.ContextOption_LazyLoadingEnabled = false;
						return Order_Details.ToArray();
					}
					finally
					{
						context.ContextOption_LazyLoadingEnabled = true;
					}
				}
			}
		}
		
		private WrappedEntityCollection<Order_Details> _wrappedOrder_Details;

		private WrappedEntityCollection<Order_Details> WrappedOrder_Details
		{
			get
			{
				if (_wrappedOrder_Details == null)
				{
					_wrappedOrder_Details = new WrappedEntityCollection<Order_Details>(this, "Order_Details", "Products");
				}
				_wrappedOrder_Details.UnderlyingEntityCollection = Order_DetailsRelatedEnd;
				return _wrappedOrder_Details;
			}
		}
		

/// <summary></summary>
/// <remarks></remarks>
		[EdmRelationshipNavigationProperty("MoxDataModel", "FK_Order_Details_Products", "Order_Details")]
		[XmlIgnore]
		[SoapIgnore]
		public
		ICollection<Order_Details> Order_Details
		{
			get
			{
				return WrappedOrder_Details;
			}
		}						
/// <summary>
/// Ta własność jest wykorzystywana przez wewnętrzne mechanizmy platformy Morii i nie powinna być bezpośrednio używana w kodzie zewnętrznym.
/// </summary>
		[DataMember]
		protected internal EntityReference<Suppliers> SuppliersRelatedEnd
		{
			get
			{
				IEntityWithRelationships ewr = this;
				return ewr.RelationshipManager.GetRelatedReference<Suppliers>("FK_Products_Suppliers", "Suppliers");
			}
			set
			{
				if (value != null)
				{
					IEntityWithRelationships ewr = this;
					ewr.RelationshipManager.InitializeRelatedReference<Suppliers>("FK_Products_Suppliers", "Suppliers", value);
				}
			}
		}
		
		internal object SuppliersNoLazyLoading
		{
			get			
			{
				var context = ObjectContext;
				if (context == null || !context.ContextOption_LazyLoadingEnabled)
				{
					return Suppliers;
				}
				else
				{
					try
					{
						context.ContextOption_LazyLoadingEnabled = false;
						return Suppliers;
					}
					finally
					{
						context.ContextOption_LazyLoadingEnabled = true;
					}
				}
			}
		}
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmRelationshipNavigationProperty("MoxDataModel", "FK_Products_Suppliers", "Suppliers")]
		[XmlIgnore]
		[SoapIgnore]
		[DataMember]
		public Suppliers Suppliers
		{
			get
			{
				return LoadEntityReference(SuppliersRelatedEnd);
			}
			
			set
			{
				HandleExplicitAssociationChange(SuppliersRelatedEnd, value, "Suppliers");
			}
		}
		
		#endregion
	}
/// <summary></summary>
/// <remarks></remarks>
	[EdmEntityType(NamespaceName = "MoxDataModel", Name = "Shippers")]
    [Serializable]
    [DataContract(IsReference = true)]
	[System.CodeDom.Compiler.GeneratedCodeAttribute("InsERT.Mox.DataModeling.DataModelCSharpCodeGenerator", "1.0.0.0")]	
		public 	
	class Shippers
		: EntityDataObjectBase
		, IIdentifiable<System.Int32>
	{
		#region type intitialization & runtime type information
		
		private static readonly System.Collections.Generic.Dictionary<string, RelationshipTraversalInfo> relationshipTraversalInfo = new RelationshipTraversalInfo[] 
		{
			FK_Orders_ShippersTraversalInfoStore.Shippers,
		}.ToDictionary(rti => rti.NavigationPropertyName);
		
/// <summary>
/// Ta własność jest wykorzystywana przez wewnętrzne mechanizmy platformy Morii i nie powinna być bezpośrednio używana w kodzie zewnętrznym.
/// </summary>
        protected override IDictionary<string, RelationshipTraversalInfo> RelationshipTraversalInfo
        {
            get
            {
                return relationshipTraversalInfo;
            }
        }

/// <summary>
/// Ta własność jest wykorzystywana przez wewnętrzne mechanizmy platformy Morii i nie powinna być bezpośrednio używana w kodzie zewnętrznym.
/// </summary>
		protected override bool TryGetInfoForRelatedEndCore(IRelatedEnd relatedEnd, out RelationshipTraversalInfo info)
        {
			var relationshipManager = ((IEntityWithRelationships)this).RelationshipManager;
			if (false)
			{
			}
			else if (relatedEnd == relationshipManager.GetRelatedEnd("FK_Orders_Shippers", "Orders"))
			{
				info = FK_Orders_ShippersTraversalInfoStore.Shippers;
				return true;
			}
			else
			{            
            	info = null;
				return false;
			}
        }
		
		#endregion
	
		#region instance initialization

/// <summary>
/// Domyślny konstruktor <see cref="T:MoxDataModel.Shippers" />.
/// </summary>
		public Shippers()
		{
			ValidateShipperID(_ShipperID);
			ValidateCompanyName(_CompanyName);
			ValidatePhone(_Phone);
		}
		
/// <summary>
/// Ta metoda jest wykorzystywana przez wewnętrzne mechanizmy platformy Morii i nie powinna być bezpośrednio używana w kodzie zewnętrznym.
/// </summary>
		protected override bool SubscribeToAssociationChangedEventsCore(string navigationProperty)
		{
			if (base.SubscribeToAssociationChangedEventsCore(navigationProperty))
			{
				if (navigationProperty == "Orders")
				{
					var relatedEnd = OrdersRelatedEnd;
					ValidateOrdersRelatedEnd(relatedEnd);
					relatedEnd.AssociationChanged += HandleOrdersRelatedEndAssociationChanged;
					return false;
				}
				return true;
			}
			else
			{
				return false;
			}
		}
		#endregion

		#region relationship validation & change notification
		
		private void ValidateOrdersRelatedEnd(EntityCollection<Orders> relatedEnd)
		{
		}
		
		private void HandleOrdersRelatedEndAssociationChanged(object sender, CollectionChangeEventArgs e)
		{
			DataErrorInfo.RemoveAllErrors("Orders");
			var entityCollection = (EntityCollection<Orders>)sender;
			ValidateOrdersRelatedEnd(entityCollection);
			HandleImplicitAssociationChange(entityCollection, e, "Orders");			
		}
		
		#endregion
	
		#region scalar property validation
		
		private void ValidateShipperID(System.Int32 value)
		{
		}
		
		private void ValidateCompanyName(System.String value)
		{
			if (value == null)
			{
				DataErrorInfo.AddError(new MemberIsNullError(), "CompanyName");
			}
			if (value != null && value.Length > 40)
			{
				DataErrorInfo.AddError(new StringLengthError(40, false), "CompanyName");
			}
		}
		
		private void ValidatePhone(System.String value)
		{
			if (value == null)
			{
				DataErrorInfo.AddError(new MemberIsNullError(), "Phone");
			}
			if (value != null && value.Length > 24)
			{
				DataErrorInfo.AddError(new StringLengthError(24, false), "Phone");
			}
		}
		
		#endregion
	
		#region explicit identifier accessor
		
		System.Int32 IIdentifiable<System.Int32>.Id
		{
			get
			{
				return ShipperID;
			}			
		}
		
		object IIdentifiable.Id
		{
			get
			{
				return ShipperID;
			}
		}
		
		Type IIdentifiable.IdType
		{
			get
			{
				return typeof(System.Int32);
			}
		}
		
		#endregion
	
		#region scalar properties
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.Int32 _ShipperID = default(System.Int32);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = true, IsNullable = false)]
		[DataMember]
		public System.Int32 ShipperID
		{
			get
			{
				return _ShipperID;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				DataErrorInfo.RemoveAllErrors("ShipperID");
				ReportScalarPropertyChanging(sink, "ShipperID", ref value);
				ValidateShipperID(value);
				ReportPropertyChanging("ShipperID");
				_ShipperID = value;
				ReportPropertyChanged("ShipperID");
				ReportScalarPropertyChanged(sink, "ShipperID");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.String _CompanyName = default(System.String);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.String CompanyName
		{
			get
			{
				return _CompanyName;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "CompanyName");
				DataErrorInfo.RemoveAllErrors("CompanyName");
				ReportScalarPropertyChanging(sink, "CompanyName", ref value);
				ValidateCompanyName(value);
				ReportPropertyChanging("CompanyName");
				_CompanyName = value;
				ReportPropertyChanged("CompanyName");
				ReportScalarPropertyChanged(sink, "CompanyName");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.String _Phone = default(System.String);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.String Phone
		{
			get
			{
				return _Phone;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "Phone");
				DataErrorInfo.RemoveAllErrors("Phone");
				ReportScalarPropertyChanging(sink, "Phone", ref value);
				ValidatePhone(value);
				ReportPropertyChanging("Phone");
				_Phone = value;
				ReportPropertyChanged("Phone");
				ReportScalarPropertyChanged(sink, "Phone");
			}
		}
		
		#endregion
		
		#region complex properties
		
		
		#endregion
		
		#region navigation properties
/// <summary>
/// Ta własność jest wykorzystywana przez wewnętrzne mechanizmy platformy Morii i nie powinna być bezpośrednio używana w kodzie zewnętrznym.
/// </summary>
		[DataMember]
		protected internal
		EntityCollection<Orders> OrdersRelatedEnd
		{
			get
			{
				IEntityWithRelationships ewr = this;
				return ewr.RelationshipManager.GetRelatedCollection<Orders>("FK_Orders_Shippers", "Orders");
			}
			set
			{
				if (value != null)
				{
					IEntityWithRelationships ewr = this;
					ewr.RelationshipManager.InitializeRelatedCollection<Orders>("FK_Orders_Shippers", "Orders", value);
				}				
			}
		}
		
		internal object OrdersNoLazyLoading
		{
			get			
			{
				var context = ObjectContext;
				if (context == null || !context.ContextOption_LazyLoadingEnabled)
				{
					return Orders;
				}
				else
				{
					try
					{
						context.ContextOption_LazyLoadingEnabled = false;
						return Orders.ToArray();
					}
					finally
					{
						context.ContextOption_LazyLoadingEnabled = true;
					}
				}
			}
		}
		
		private WrappedEntityCollection<Orders> _wrappedOrders;

		private WrappedEntityCollection<Orders> WrappedOrders
		{
			get
			{
				if (_wrappedOrders == null)
				{
					_wrappedOrders = new WrappedEntityCollection<Orders>(this, "Orders", "Shippers");
				}
				_wrappedOrders.UnderlyingEntityCollection = OrdersRelatedEnd;
				return _wrappedOrders;
			}
		}
		

/// <summary></summary>
/// <remarks></remarks>
		[EdmRelationshipNavigationProperty("MoxDataModel", "FK_Orders_Shippers", "Orders")]
		[XmlIgnore]
		[SoapIgnore]
		public
		ICollection<Orders> Orders
		{
			get
			{
				return WrappedOrders;
			}
		}						
		#endregion
	}
/// <summary></summary>
/// <remarks></remarks>
	[EdmEntityType(NamespaceName = "MoxDataModel", Name = "Suppliers")]
    [Serializable]
    [DataContract(IsReference = true)]
	[System.CodeDom.Compiler.GeneratedCodeAttribute("InsERT.Mox.DataModeling.DataModelCSharpCodeGenerator", "1.0.0.0")]	
		public 	
	class Suppliers
		: EntityDataObjectBase
		, IIdentifiable<System.Int32>
	{
		#region type intitialization & runtime type information
		
		private static readonly System.Collections.Generic.Dictionary<string, RelationshipTraversalInfo> relationshipTraversalInfo = new RelationshipTraversalInfo[] 
		{
			FK_Products_SuppliersTraversalInfoStore.Suppliers,
		}.ToDictionary(rti => rti.NavigationPropertyName);
		
/// <summary>
/// Ta własność jest wykorzystywana przez wewnętrzne mechanizmy platformy Morii i nie powinna być bezpośrednio używana w kodzie zewnętrznym.
/// </summary>
        protected override IDictionary<string, RelationshipTraversalInfo> RelationshipTraversalInfo
        {
            get
            {
                return relationshipTraversalInfo;
            }
        }

/// <summary>
/// Ta własność jest wykorzystywana przez wewnętrzne mechanizmy platformy Morii i nie powinna być bezpośrednio używana w kodzie zewnętrznym.
/// </summary>
		protected override bool TryGetInfoForRelatedEndCore(IRelatedEnd relatedEnd, out RelationshipTraversalInfo info)
        {
			var relationshipManager = ((IEntityWithRelationships)this).RelationshipManager;
			if (false)
			{
			}
			else if (relatedEnd == relationshipManager.GetRelatedEnd("FK_Products_Suppliers", "Products"))
			{
				info = FK_Products_SuppliersTraversalInfoStore.Suppliers;
				return true;
			}
			else
			{            
            	info = null;
				return false;
			}
        }
		
		#endregion
	
		#region instance initialization

/// <summary>
/// Domyślny konstruktor <see cref="T:MoxDataModel.Suppliers" />.
/// </summary>
		public Suppliers()
		{
			ValidateSupplierID(_SupplierID);
			ValidateCompanyName(_CompanyName);
			ValidateContactName(_ContactName);
			ValidateContactTitle(_ContactTitle);
			ValidateAddress(_Address);
			ValidateCity(_City);
			ValidateRegion(_Region);
			ValidatePostalCode(_PostalCode);
			ValidateCountry(_Country);
			ValidatePhone(_Phone);
			ValidateFax(_Fax);
			ValidateHomePage(_HomePage);
		}
		
/// <summary>
/// Ta metoda jest wykorzystywana przez wewnętrzne mechanizmy platformy Morii i nie powinna być bezpośrednio używana w kodzie zewnętrznym.
/// </summary>
		protected override bool SubscribeToAssociationChangedEventsCore(string navigationProperty)
		{
			if (base.SubscribeToAssociationChangedEventsCore(navigationProperty))
			{
				if (navigationProperty == "Products")
				{
					var relatedEnd = ProductsRelatedEnd;
					ValidateProductsRelatedEnd(relatedEnd);
					relatedEnd.AssociationChanged += HandleProductsRelatedEndAssociationChanged;
					return false;
				}
				return true;
			}
			else
			{
				return false;
			}
		}
		#endregion

		#region relationship validation & change notification
		
		private void ValidateProductsRelatedEnd(EntityCollection<Products> relatedEnd)
		{
		}
		
		private void HandleProductsRelatedEndAssociationChanged(object sender, CollectionChangeEventArgs e)
		{
			DataErrorInfo.RemoveAllErrors("Products");
			var entityCollection = (EntityCollection<Products>)sender;
			ValidateProductsRelatedEnd(entityCollection);
			HandleImplicitAssociationChange(entityCollection, e, "Products");			
		}
		
		#endregion
	
		#region scalar property validation
		
		private void ValidateSupplierID(System.Int32 value)
		{
		}
		
		private void ValidateCompanyName(System.String value)
		{
			if (value == null)
			{
				DataErrorInfo.AddError(new MemberIsNullError(), "CompanyName");
			}
			if (value != null && value.Length > 40)
			{
				DataErrorInfo.AddError(new StringLengthError(40, false), "CompanyName");
			}
		}
		
		private void ValidateContactName(System.String value)
		{
			if (value == null)
			{
				DataErrorInfo.AddError(new MemberIsNullError(), "ContactName");
			}
			if (value != null && value.Length > 30)
			{
				DataErrorInfo.AddError(new StringLengthError(30, false), "ContactName");
			}
		}
		
		private void ValidateContactTitle(System.String value)
		{
			if (value == null)
			{
				DataErrorInfo.AddError(new MemberIsNullError(), "ContactTitle");
			}
			if (value != null && value.Length > 30)
			{
				DataErrorInfo.AddError(new StringLengthError(30, false), "ContactTitle");
			}
		}
		
		private void ValidateAddress(System.String value)
		{
			if (value == null)
			{
				DataErrorInfo.AddError(new MemberIsNullError(), "Address");
			}
			if (value != null && value.Length > 60)
			{
				DataErrorInfo.AddError(new StringLengthError(60, false), "Address");
			}
		}
		
		private void ValidateCity(System.String value)
		{
			if (value == null)
			{
				DataErrorInfo.AddError(new MemberIsNullError(), "City");
			}
			if (value != null && value.Length > 15)
			{
				DataErrorInfo.AddError(new StringLengthError(15, false), "City");
			}
		}
		
		private void ValidateRegion(System.String value)
		{
			if (value == null)
			{
				DataErrorInfo.AddError(new MemberIsNullError(), "Region");
			}
			if (value != null && value.Length > 15)
			{
				DataErrorInfo.AddError(new StringLengthError(15, false), "Region");
			}
		}
		
		private void ValidatePostalCode(System.String value)
		{
			if (value == null)
			{
				DataErrorInfo.AddError(new MemberIsNullError(), "PostalCode");
			}
			if (value != null && value.Length > 10)
			{
				DataErrorInfo.AddError(new StringLengthError(10, false), "PostalCode");
			}
		}
		
		private void ValidateCountry(System.String value)
		{
			if (value == null)
			{
				DataErrorInfo.AddError(new MemberIsNullError(), "Country");
			}
			if (value != null && value.Length > 15)
			{
				DataErrorInfo.AddError(new StringLengthError(15, false), "Country");
			}
		}
		
		private void ValidatePhone(System.String value)
		{
			if (value == null)
			{
				DataErrorInfo.AddError(new MemberIsNullError(), "Phone");
			}
			if (value != null && value.Length > 24)
			{
				DataErrorInfo.AddError(new StringLengthError(24, false), "Phone");
			}
		}
		
		private void ValidateFax(System.String value)
		{
			if (value == null)
			{
				DataErrorInfo.AddError(new MemberIsNullError(), "Fax");
			}
			if (value != null && value.Length > 24)
			{
				DataErrorInfo.AddError(new StringLengthError(24, false), "Fax");
			}
		}
		
		private void ValidateHomePage(System.String value)
		{
			if (value == null)
			{
				DataErrorInfo.AddError(new MemberIsNullError(), "HomePage");
			}
		}
		
		#endregion
	
		#region explicit identifier accessor
		
		System.Int32 IIdentifiable<System.Int32>.Id
		{
			get
			{
				return SupplierID;
			}			
		}
		
		object IIdentifiable.Id
		{
			get
			{
				return SupplierID;
			}
		}
		
		Type IIdentifiable.IdType
		{
			get
			{
				return typeof(System.Int32);
			}
		}
		
		#endregion
	
		#region scalar properties
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.Int32 _SupplierID = default(System.Int32);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = true, IsNullable = false)]
		[DataMember]
		public System.Int32 SupplierID
		{
			get
			{
				return _SupplierID;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				DataErrorInfo.RemoveAllErrors("SupplierID");
				ReportScalarPropertyChanging(sink, "SupplierID", ref value);
				ValidateSupplierID(value);
				ReportPropertyChanging("SupplierID");
				_SupplierID = value;
				ReportPropertyChanged("SupplierID");
				ReportScalarPropertyChanged(sink, "SupplierID");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.String _CompanyName = default(System.String);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.String CompanyName
		{
			get
			{
				return _CompanyName;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "CompanyName");
				DataErrorInfo.RemoveAllErrors("CompanyName");
				ReportScalarPropertyChanging(sink, "CompanyName", ref value);
				ValidateCompanyName(value);
				ReportPropertyChanging("CompanyName");
				_CompanyName = value;
				ReportPropertyChanged("CompanyName");
				ReportScalarPropertyChanged(sink, "CompanyName");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.String _ContactName = default(System.String);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.String ContactName
		{
			get
			{
				return _ContactName;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "ContactName");
				DataErrorInfo.RemoveAllErrors("ContactName");
				ReportScalarPropertyChanging(sink, "ContactName", ref value);
				ValidateContactName(value);
				ReportPropertyChanging("ContactName");
				_ContactName = value;
				ReportPropertyChanged("ContactName");
				ReportScalarPropertyChanged(sink, "ContactName");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.String _ContactTitle = default(System.String);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.String ContactTitle
		{
			get
			{
				return _ContactTitle;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "ContactTitle");
				DataErrorInfo.RemoveAllErrors("ContactTitle");
				ReportScalarPropertyChanging(sink, "ContactTitle", ref value);
				ValidateContactTitle(value);
				ReportPropertyChanging("ContactTitle");
				_ContactTitle = value;
				ReportPropertyChanged("ContactTitle");
				ReportScalarPropertyChanged(sink, "ContactTitle");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.String _Address = default(System.String);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.String Address
		{
			get
			{
				return _Address;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "Address");
				DataErrorInfo.RemoveAllErrors("Address");
				ReportScalarPropertyChanging(sink, "Address", ref value);
				ValidateAddress(value);
				ReportPropertyChanging("Address");
				_Address = value;
				ReportPropertyChanged("Address");
				ReportScalarPropertyChanged(sink, "Address");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.String _City = default(System.String);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.String City
		{
			get
			{
				return _City;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "City");
				DataErrorInfo.RemoveAllErrors("City");
				ReportScalarPropertyChanging(sink, "City", ref value);
				ValidateCity(value);
				ReportPropertyChanging("City");
				_City = value;
				ReportPropertyChanged("City");
				ReportScalarPropertyChanged(sink, "City");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.String _Region = default(System.String);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.String Region
		{
			get
			{
				return _Region;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "Region");
				DataErrorInfo.RemoveAllErrors("Region");
				ReportScalarPropertyChanging(sink, "Region", ref value);
				ValidateRegion(value);
				ReportPropertyChanging("Region");
				_Region = value;
				ReportPropertyChanged("Region");
				ReportScalarPropertyChanged(sink, "Region");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.String _PostalCode = default(System.String);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.String PostalCode
		{
			get
			{
				return _PostalCode;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "PostalCode");
				DataErrorInfo.RemoveAllErrors("PostalCode");
				ReportScalarPropertyChanging(sink, "PostalCode", ref value);
				ValidatePostalCode(value);
				ReportPropertyChanging("PostalCode");
				_PostalCode = value;
				ReportPropertyChanged("PostalCode");
				ReportScalarPropertyChanged(sink, "PostalCode");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.String _Country = default(System.String);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.String Country
		{
			get
			{
				return _Country;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "Country");
				DataErrorInfo.RemoveAllErrors("Country");
				ReportScalarPropertyChanging(sink, "Country", ref value);
				ValidateCountry(value);
				ReportPropertyChanging("Country");
				_Country = value;
				ReportPropertyChanged("Country");
				ReportScalarPropertyChanged(sink, "Country");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.String _Phone = default(System.String);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.String Phone
		{
			get
			{
				return _Phone;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "Phone");
				DataErrorInfo.RemoveAllErrors("Phone");
				ReportScalarPropertyChanging(sink, "Phone", ref value);
				ValidatePhone(value);
				ReportPropertyChanging("Phone");
				_Phone = value;
				ReportPropertyChanged("Phone");
				ReportScalarPropertyChanged(sink, "Phone");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.String _Fax = default(System.String);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.String Fax
		{
			get
			{
				return _Fax;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "Fax");
				DataErrorInfo.RemoveAllErrors("Fax");
				ReportScalarPropertyChanging(sink, "Fax", ref value);
				ValidateFax(value);
				ReportPropertyChanging("Fax");
				_Fax = value;
				ReportPropertyChanged("Fax");
				ReportScalarPropertyChanged(sink, "Fax");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.String _HomePage = default(System.String);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.String HomePage
		{
			get
			{
				return _HomePage;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "HomePage");
				DataErrorInfo.RemoveAllErrors("HomePage");
				ReportScalarPropertyChanging(sink, "HomePage", ref value);
				ValidateHomePage(value);
				ReportPropertyChanging("HomePage");
				_HomePage = value;
				ReportPropertyChanged("HomePage");
				ReportScalarPropertyChanged(sink, "HomePage");
			}
		}
		
		#endregion
		
		#region complex properties
		
		
		#endregion
		
		#region navigation properties
/// <summary>
/// Ta własność jest wykorzystywana przez wewnętrzne mechanizmy platformy Morii i nie powinna być bezpośrednio używana w kodzie zewnętrznym.
/// </summary>
		[DataMember]
		protected internal
		EntityCollection<Products> ProductsRelatedEnd
		{
			get
			{
				IEntityWithRelationships ewr = this;
				return ewr.RelationshipManager.GetRelatedCollection<Products>("FK_Products_Suppliers", "Products");
			}
			set
			{
				if (value != null)
				{
					IEntityWithRelationships ewr = this;
					ewr.RelationshipManager.InitializeRelatedCollection<Products>("FK_Products_Suppliers", "Products", value);
				}				
			}
		}
		
		internal object ProductsNoLazyLoading
		{
			get			
			{
				var context = ObjectContext;
				if (context == null || !context.ContextOption_LazyLoadingEnabled)
				{
					return Products;
				}
				else
				{
					try
					{
						context.ContextOption_LazyLoadingEnabled = false;
						return Products.ToArray();
					}
					finally
					{
						context.ContextOption_LazyLoadingEnabled = true;
					}
				}
			}
		}
		
		private WrappedEntityCollection<Products> _wrappedProducts;

		private WrappedEntityCollection<Products> WrappedProducts
		{
			get
			{
				if (_wrappedProducts == null)
				{
					_wrappedProducts = new WrappedEntityCollection<Products>(this, "Products", "Suppliers");
				}
				_wrappedProducts.UnderlyingEntityCollection = ProductsRelatedEnd;
				return _wrappedProducts;
			}
		}
		

/// <summary></summary>
/// <remarks></remarks>
		[EdmRelationshipNavigationProperty("MoxDataModel", "FK_Products_Suppliers", "Products")]
		[XmlIgnore]
		[SoapIgnore]
		public
		ICollection<Products> Products
		{
			get
			{
				return WrappedProducts;
			}
		}						
		#endregion
	}
	#endregion
	
	#region complex types

	#endregion
	
	#region runtime type information store
	
	[System.CodeDom.Compiler.GeneratedCodeAttribute("InsERT.Mox.DataModeling.DataModelCSharpCodeGenerator", "1.0.0.0")]
	internal static class FK_Products_CategoriesTraversalInfoStore
	{
		static FK_Products_CategoriesTraversalInfoStore()
		{
			RelationshipTraversalInfo.CreatePair
			(
				typeof(Categories),
				"Products",
				true,
				o =>
				{
					var e = (Categories)o;
					return e.ProductsNoLazyLoading;
				},
				
				typeof(Products),
				"Categories",
				false,
				o =>
				{
					var e = (Products)o;					
					return e.CategoriesNoLazyLoading;
				},

				out Categories,
				out Products
			);
		}
		
		internal static readonly RelationshipTraversalInfo Categories;
		internal static readonly RelationshipTraversalInfo Products;
	}
	
	[System.CodeDom.Compiler.GeneratedCodeAttribute("InsERT.Mox.DataModeling.DataModelCSharpCodeGenerator", "1.0.0.0")]
	internal static class FK_Orders_CustomersTraversalInfoStore
	{
		static FK_Orders_CustomersTraversalInfoStore()
		{
			RelationshipTraversalInfo.CreatePair
			(
				typeof(Customers),
				"Orders",
				true,
				o =>
				{
					var e = (Customers)o;
					return e.OrdersNoLazyLoading;
				},
				
				typeof(Orders),
				"Customers",
				false,
				o =>
				{
					var e = (Orders)o;					
					return e.CustomersNoLazyLoading;
				},

				out Customers,
				out Orders
			);
		}
		
		internal static readonly RelationshipTraversalInfo Customers;
		internal static readonly RelationshipTraversalInfo Orders;
	}
	
	[System.CodeDom.Compiler.GeneratedCodeAttribute("InsERT.Mox.DataModeling.DataModelCSharpCodeGenerator", "1.0.0.0")]
	internal static class FK_Employees_EmployeesTraversalInfoStore
	{
		static FK_Employees_EmployeesTraversalInfoStore()
		{
			RelationshipTraversalInfo.CreatePair
			(
				typeof(Employees),
				"Employees1",
				true,
				o =>
				{
					var e = (Employees)o;
					return e.Employees1NoLazyLoading;
				},
				
				typeof(Employees),
				"Employees2",
				false,
				o =>
				{
					var e = (Employees)o;					
					return e.Employees2NoLazyLoading;
				},

				out Employees,
				out Employees1
			);
		}
		
		internal static readonly RelationshipTraversalInfo Employees;
		internal static readonly RelationshipTraversalInfo Employees1;
	}
	
	[System.CodeDom.Compiler.GeneratedCodeAttribute("InsERT.Mox.DataModeling.DataModelCSharpCodeGenerator", "1.0.0.0")]
	internal static class FK_Orders_EmployeesTraversalInfoStore
	{
		static FK_Orders_EmployeesTraversalInfoStore()
		{
			RelationshipTraversalInfo.CreatePair
			(
				typeof(Employees),
				"Orders",
				true,
				o =>
				{
					var e = (Employees)o;
					return e.OrdersNoLazyLoading;
				},
				
				typeof(Orders),
				"Employees",
				false,
				o =>
				{
					var e = (Orders)o;					
					return e.EmployeesNoLazyLoading;
				},

				out Employees,
				out Orders
			);
		}
		
		internal static readonly RelationshipTraversalInfo Employees;
		internal static readonly RelationshipTraversalInfo Orders;
	}
	
	[System.CodeDom.Compiler.GeneratedCodeAttribute("InsERT.Mox.DataModeling.DataModelCSharpCodeGenerator", "1.0.0.0")]
	internal static class FK_Order_Details_OrdersTraversalInfoStore
	{
		static FK_Order_Details_OrdersTraversalInfoStore()
		{
			RelationshipTraversalInfo.CreatePair
			(
				typeof(Orders),
				"Order_Details",
				true,
				o =>
				{
					var e = (Orders)o;
					return e.Order_DetailsNoLazyLoading;
				},
				
				typeof(Order_Details),
				"Orders",
				false,
				o =>
				{
					var e = (Order_Details)o;					
					return e.OrdersNoLazyLoading;
				},

				out Orders,
				out Order_Details
			);
		}
		
		internal static readonly RelationshipTraversalInfo Orders;
		internal static readonly RelationshipTraversalInfo Order_Details;
	}
	
	[System.CodeDom.Compiler.GeneratedCodeAttribute("InsERT.Mox.DataModeling.DataModelCSharpCodeGenerator", "1.0.0.0")]
	internal static class FK_Order_Details_ProductsTraversalInfoStore
	{
		static FK_Order_Details_ProductsTraversalInfoStore()
		{
			RelationshipTraversalInfo.CreatePair
			(
				typeof(Products),
				"Order_Details",
				true,
				o =>
				{
					var e = (Products)o;
					return e.Order_DetailsNoLazyLoading;
				},
				
				typeof(Order_Details),
				"Products",
				false,
				o =>
				{
					var e = (Order_Details)o;					
					return e.ProductsNoLazyLoading;
				},

				out Products,
				out Order_Details
			);
		}
		
		internal static readonly RelationshipTraversalInfo Products;
		internal static readonly RelationshipTraversalInfo Order_Details;
	}
	
	[System.CodeDom.Compiler.GeneratedCodeAttribute("InsERT.Mox.DataModeling.DataModelCSharpCodeGenerator", "1.0.0.0")]
	internal static class FK_Orders_ShippersTraversalInfoStore
	{
		static FK_Orders_ShippersTraversalInfoStore()
		{
			RelationshipTraversalInfo.CreatePair
			(
				typeof(Shippers),
				"Orders",
				true,
				o =>
				{
					var e = (Shippers)o;
					return e.OrdersNoLazyLoading;
				},
				
				typeof(Orders),
				"Shippers",
				false,
				o =>
				{
					var e = (Orders)o;					
					return e.ShippersNoLazyLoading;
				},

				out Shippers,
				out Orders
			);
		}
		
		internal static readonly RelationshipTraversalInfo Shippers;
		internal static readonly RelationshipTraversalInfo Orders;
	}
	
	[System.CodeDom.Compiler.GeneratedCodeAttribute("InsERT.Mox.DataModeling.DataModelCSharpCodeGenerator", "1.0.0.0")]
	internal static class FK_Products_SuppliersTraversalInfoStore
	{
		static FK_Products_SuppliersTraversalInfoStore()
		{
			RelationshipTraversalInfo.CreatePair
			(
				typeof(Suppliers),
				"Products",
				true,
				o =>
				{
					var e = (Suppliers)o;
					return e.ProductsNoLazyLoading;
				},
				
				typeof(Products),
				"Suppliers",
				false,
				o =>
				{
					var e = (Products)o;					
					return e.SuppliersNoLazyLoading;
				},

				out Suppliers,
				out Products
			);
		}
		
		internal static readonly RelationshipTraversalInfo Suppliers;
		internal static readonly RelationshipTraversalInfo Products;
	}
	
	#endregion

	#region repository & eager relationship loading interfaces & implementation
	
/// <summary>
/// Ładuje encje bezpośrednio powiązane z encjami typu <see cref="T:MoxDataModel.Categories" />
/// </summary>
	[System.CodeDom.Compiler.GeneratedCodeAttribute("InsERT.Mox.DataModeling.DataModelCSharpCodeGenerator", "1.0.0.0")]
	
	public interface ICategoriesRelationshipLoader
	{
/// <summary>
/// Sprawdza, czy dla danej encji typu <see cref="T:MoxDataModel.Categories" /> są załadowane powiązane encje osiągalne przez własność <see cref="P:MoxDataModel.Categories.Products" />.
/// </summary>
		bool AreProductsLoaded(Categories categories);
/// <summary>
/// Ładuje powiązane encje osiągalne przez własność <see cref="P:MoxDataModel.Categories.Products" /> w podanej encji typu <see cref="T:MoxDataModel.Categories" />.
/// </summary>
		void LoadProducts(Categories categories);
	}
	
/// <summary>
/// Repozytorium encji typu <see cref="T:MoxDataModel.Categories" />
/// </summary>
	[System.CodeDom.Compiler.GeneratedCodeAttribute("InsERT.Mox.DataModeling.DataModelCSharpCodeGenerator", "1.0.0.0")]
	public interface ICategoriesRepository
		: IRepository<Categories, System.Int32>
		, ICategoriesRelationshipLoader
	{
	}
	
/// <summary>
/// Repozytorium encji typu <see cref="MoxDataModel.Categories" /> ze zbioru Categories.
/// </summary>
	[System.CodeDom.Compiler.GeneratedCodeAttribute("InsERT.Mox.DataModeling.DataModelCSharpCodeGenerator", "1.0.0.0")]
	public class EFCategoriesFromCategoriesRepository
		: EFRepositoryBase<Categories, Categories, System.Int32, dbo>
		, ICategoriesRepository
		, InsERT.Mox.ObiektyBiznesowe.IDane<Categories>
	{
/// <summary>
/// Tworzy repozytorium pobierające encje w podanym kontekście ADO.NET EF.
/// </summary>
		public EFCategoriesFromCategoriesRepository(dbo objectContext)
			: base(objectContext)
		{
		}
		
/// <summary>
/// Zbiór encji, z którego korzysta repozytorium.
/// </summary>
		protected override ObjectSet<Categories> ObjectSet
		{
			get
			{
				return ObjectContext.Categories;
			}
		}
		
/// <summary>
/// Sprawdza, czy dla danej encji typu <see cref="T:MoxDataModel.Categories" /> są załadowane powiązane encje osiągalne przez własność <see cref="P:MoxDataModel.Categories.Products" />.
/// </summary>
		public bool AreProductsLoaded(Categories categories)
		{
			return categories.ProductsRelatedEnd.IsLoaded;
		}
		
/// <summary>
/// Ładuje powiązane encje osiągalne przez własność <see cref="P:MoxDataModel.Categories.Products" /> w podanej encji typu <see cref="T:MoxDataModel.Categories" />.
/// </summary>
		public void LoadProducts(Categories categories)
		{
			if (categories.EntityState == EntityState.Unchanged ||
				categories.EntityState == EntityState.Modified)
			{
				categories.ProductsRelatedEnd.Load();
			}
		}
				
	}

	
/// <summary>
/// Ładuje encje bezpośrednio powiązane z encjami typu <see cref="T:MoxDataModel.Customers" />
/// </summary>
	[System.CodeDom.Compiler.GeneratedCodeAttribute("InsERT.Mox.DataModeling.DataModelCSharpCodeGenerator", "1.0.0.0")]
	
	public interface ICustomersRelationshipLoader
	{
/// <summary>
/// Sprawdza, czy dla danej encji typu <see cref="T:MoxDataModel.Customers" /> są załadowane powiązane encje osiągalne przez własność <see cref="P:MoxDataModel.Customers.Orders" />.
/// </summary>
		bool AreOrdersLoaded(Customers customers);
/// <summary>
/// Ładuje powiązane encje osiągalne przez własność <see cref="P:MoxDataModel.Customers.Orders" /> w podanej encji typu <see cref="T:MoxDataModel.Customers" />.
/// </summary>
		void LoadOrders(Customers customers);
	}
	
/// <summary>
/// Repozytorium encji typu <see cref="T:MoxDataModel.Customers" />
/// </summary>
	[System.CodeDom.Compiler.GeneratedCodeAttribute("InsERT.Mox.DataModeling.DataModelCSharpCodeGenerator", "1.0.0.0")]
	public interface ICustomersRepository
		: IRepository<Customers, System.String>
		, ICustomersRelationshipLoader
	{
	}
	
/// <summary>
/// Repozytorium encji typu <see cref="MoxDataModel.Customers" /> ze zbioru Customers.
/// </summary>
	[System.CodeDom.Compiler.GeneratedCodeAttribute("InsERT.Mox.DataModeling.DataModelCSharpCodeGenerator", "1.0.0.0")]
	public class EFCustomersFromCustomersRepository
		: EFRepositoryBase<Customers, Customers, System.String, dbo>
		, ICustomersRepository
		, InsERT.Mox.ObiektyBiznesowe.IDane<Customers>
	{
/// <summary>
/// Tworzy repozytorium pobierające encje w podanym kontekście ADO.NET EF.
/// </summary>
		public EFCustomersFromCustomersRepository(dbo objectContext)
			: base(objectContext)
		{
		}
		
/// <summary>
/// Zbiór encji, z którego korzysta repozytorium.
/// </summary>
		protected override ObjectSet<Customers> ObjectSet
		{
			get
			{
				return ObjectContext.Customers;
			}
		}
		
/// <summary>
/// Sprawdza, czy dla danej encji typu <see cref="T:MoxDataModel.Customers" /> są załadowane powiązane encje osiągalne przez własność <see cref="P:MoxDataModel.Customers.Orders" />.
/// </summary>
		public bool AreOrdersLoaded(Customers customers)
		{
			return customers.OrdersRelatedEnd.IsLoaded;
		}
		
/// <summary>
/// Ładuje powiązane encje osiągalne przez własność <see cref="P:MoxDataModel.Customers.Orders" /> w podanej encji typu <see cref="T:MoxDataModel.Customers" />.
/// </summary>
		public void LoadOrders(Customers customers)
		{
			if (customers.EntityState == EntityState.Unchanged ||
				customers.EntityState == EntityState.Modified)
			{
				customers.OrdersRelatedEnd.Load();
			}
		}
				
	}

	
/// <summary>
/// Ładuje encje bezpośrednio powiązane z encjami typu <see cref="T:MoxDataModel.Employees" />
/// </summary>
	[System.CodeDom.Compiler.GeneratedCodeAttribute("InsERT.Mox.DataModeling.DataModelCSharpCodeGenerator", "1.0.0.0")]
	
	public interface IEmployeesRelationshipLoader
	{
/// <summary>
/// Sprawdza, czy dla danej encji typu <see cref="T:MoxDataModel.Employees" /> są załadowane powiązane encje osiągalne przez własność <see cref="P:MoxDataModel.Employees.Employees1" />.
/// </summary>
		bool AreEmployees1Loaded(Employees employees);
/// <summary>
/// Ładuje powiązane encje osiągalne przez własność <see cref="P:MoxDataModel.Employees.Employees1" /> w podanej encji typu <see cref="T:MoxDataModel.Employees" />.
/// </summary>
		void LoadEmployees1(Employees employees);
/// <summary>
/// Sprawdza, czy dla danej encji typu <see cref="T:MoxDataModel.Employees" /> jest załadowana powiązana encja osiągalna przez własność <see cref="P:MoxDataModel.Employees.Employees2" />.
/// </summary>
		bool IsEmployees2Loaded(Employees employees);		
/// <summary>
/// Ładuje powiązaną encję osiągalną przez własność <see cref="P:MoxDataModel.Employees.Employees2" /> w podanej encji typu <see cref="T:MoxDataModel.Employees" />.
/// </summary>
		void LoadEmployees2(Employees employees);
/// <summary>
/// Sprawdza, czy dla danej encji typu <see cref="T:MoxDataModel.Employees" /> są załadowane powiązane encje osiągalne przez własność <see cref="P:MoxDataModel.Employees.Orders" />.
/// </summary>
		bool AreOrdersLoaded(Employees employees);
/// <summary>
/// Ładuje powiązane encje osiągalne przez własność <see cref="P:MoxDataModel.Employees.Orders" /> w podanej encji typu <see cref="T:MoxDataModel.Employees" />.
/// </summary>
		void LoadOrders(Employees employees);
	}
	
/// <summary>
/// Repozytorium encji typu <see cref="T:MoxDataModel.Employees" />
/// </summary>
	[System.CodeDom.Compiler.GeneratedCodeAttribute("InsERT.Mox.DataModeling.DataModelCSharpCodeGenerator", "1.0.0.0")]
	public interface IEmployeesRepository
		: IRepository<Employees, System.Int32>
		, IEmployeesRelationshipLoader
	{
	}
	
/// <summary>
/// Repozytorium encji typu <see cref="MoxDataModel.Employees" /> ze zbioru Employees.
/// </summary>
	[System.CodeDom.Compiler.GeneratedCodeAttribute("InsERT.Mox.DataModeling.DataModelCSharpCodeGenerator", "1.0.0.0")]
	public class EFEmployeesFromEmployeesRepository
		: EFRepositoryBase<Employees, Employees, System.Int32, dbo>
		, IEmployeesRepository
		, InsERT.Mox.ObiektyBiznesowe.IDane<Employees>
	{
/// <summary>
/// Tworzy repozytorium pobierające encje w podanym kontekście ADO.NET EF.
/// </summary>
		public EFEmployeesFromEmployeesRepository(dbo objectContext)
			: base(objectContext)
		{
		}
		
/// <summary>
/// Zbiór encji, z którego korzysta repozytorium.
/// </summary>
		protected override ObjectSet<Employees> ObjectSet
		{
			get
			{
				return ObjectContext.Employees;
			}
		}
		
/// <summary>
/// Sprawdza, czy dla danej encji typu <see cref="T:MoxDataModel.Employees" /> są załadowane powiązane encje osiągalne przez własność <see cref="P:MoxDataModel.Employees.Employees1" />.
/// </summary>
		public bool AreEmployees1Loaded(Employees employees)
		{
			return employees.Employees1RelatedEnd.IsLoaded;
		}
		
/// <summary>
/// Ładuje powiązane encje osiągalne przez własność <see cref="P:MoxDataModel.Employees.Employees1" /> w podanej encji typu <see cref="T:MoxDataModel.Employees" />.
/// </summary>
		public void LoadEmployees1(Employees employees)
		{
			if (employees.EntityState == EntityState.Unchanged ||
				employees.EntityState == EntityState.Modified)
			{
				employees.Employees1RelatedEnd.Load();
			}
		}
				
/// <summary>
/// Sprawdza, czy dla danej encji typu <see cref="T:MoxDataModel.Employees" /> jest załadowana powiązana encja osiągalna przez własność <see cref="P:MoxDataModel.Employees.Employees2" />.
/// </summary>
		public bool IsEmployees2Loaded(Employees employees)
		{
			return employees.Employees2RelatedEnd.IsLoaded;
		}
		
/// <summary>
/// Ładuje powiązaną encję osiągalną przez własność <see cref="P:MoxDataModel.Employees.Employees2" /> w podanej encji typu <see cref="T:MoxDataModel.Employees" />.
/// </summary>
		public void LoadEmployees2(Employees employees)
		{
			if (employees.EntityState == EntityState.Unchanged ||
				employees.EntityState == EntityState.Modified)
			{
				employees.Employees2RelatedEnd.Load();
			}
		}
				
/// <summary>
/// Sprawdza, czy dla danej encji typu <see cref="T:MoxDataModel.Employees" /> są załadowane powiązane encje osiągalne przez własność <see cref="P:MoxDataModel.Employees.Orders" />.
/// </summary>
		public bool AreOrdersLoaded(Employees employees)
		{
			return employees.OrdersRelatedEnd.IsLoaded;
		}
		
/// <summary>
/// Ładuje powiązane encje osiągalne przez własność <see cref="P:MoxDataModel.Employees.Orders" /> w podanej encji typu <see cref="T:MoxDataModel.Employees" />.
/// </summary>
		public void LoadOrders(Employees employees)
		{
			if (employees.EntityState == EntityState.Unchanged ||
				employees.EntityState == EntityState.Modified)
			{
				employees.OrdersRelatedEnd.Load();
			}
		}
				
	}

	
/// <summary>
/// Ładuje encje bezpośrednio powiązane z encjami typu <see cref="T:MoxDataModel.Order_Details" />
/// </summary>
	[System.CodeDom.Compiler.GeneratedCodeAttribute("InsERT.Mox.DataModeling.DataModelCSharpCodeGenerator", "1.0.0.0")]
	
	public interface IOrder_DetailsRelationshipLoader
	{
/// <summary>
/// Sprawdza, czy dla danej encji typu <see cref="T:MoxDataModel.Order_Details" /> jest załadowana powiązana encja osiągalna przez własność <see cref="P:MoxDataModel.Order_Details.Orders" />.
/// </summary>
		bool IsOrdersLoaded(Order_Details order_details);		
/// <summary>
/// Ładuje powiązaną encję osiągalną przez własność <see cref="P:MoxDataModel.Order_Details.Orders" /> w podanej encji typu <see cref="T:MoxDataModel.Order_Details" />.
/// </summary>
		void LoadOrders(Order_Details order_details);
/// <summary>
/// Sprawdza, czy dla danej encji typu <see cref="T:MoxDataModel.Order_Details" /> jest załadowana powiązana encja osiągalna przez własność <see cref="P:MoxDataModel.Order_Details.Products" />.
/// </summary>
		bool IsProductsLoaded(Order_Details order_details);		
/// <summary>
/// Ładuje powiązaną encję osiągalną przez własność <see cref="P:MoxDataModel.Order_Details.Products" /> w podanej encji typu <see cref="T:MoxDataModel.Order_Details" />.
/// </summary>
		void LoadProducts(Order_Details order_details);
	}
	
/// <summary>
/// Repozytorium encji typu <see cref="T:MoxDataModel.Order_Details" />
/// </summary>
	[System.CodeDom.Compiler.GeneratedCodeAttribute("InsERT.Mox.DataModeling.DataModelCSharpCodeGenerator", "1.0.0.0")]
	public interface IOrder_DetailsRepository
		: IRepository<Order_Details>
		, IOrder_DetailsRelationshipLoader
	{
	}
	
/// <summary>
/// Repozytorium encji typu <see cref="MoxDataModel.Order_Details" /> ze zbioru Order_Details.
/// </summary>
	public class EFOrder_DetailsFromOrder_DetailsRepository
		: EFRepositoryBase<Order_Details, Order_Details, dbo>
		, IOrder_DetailsRepository
		, InsERT.Mox.ObiektyBiznesowe.IDane<Order_Details>
	{
/// <summary>
/// Tworzy repozytorium pobierające encje w podanym kontekście ADO.NET EF.
/// </summary>
		public EFOrder_DetailsFromOrder_DetailsRepository(dbo objectContext)
			: base(objectContext)
		{
		}
		
/// <summary>
/// Zbiór encji, z którego korzysta repozytorium.
/// </summary>
		protected override ObjectSet<Order_Details> ObjectSet
		{
			get
			{
				return ObjectContext.Order_Details;
			}
		}
		
/// <summary>
/// Sprawdza, czy dla danej encji typu <see cref="T:MoxDataModel.Order_Details" /> jest załadowana powiązana encja osiągalna przez własność <see cref="P:MoxDataModel.Order_Details.Orders" />.
/// </summary>
		public bool IsOrdersLoaded(Order_Details order_details)
		{
			return order_details.OrdersRelatedEnd.IsLoaded;
		}
		
/// <summary>
/// Ładuje powiązaną encję osiągalną przez własność <see cref="P:MoxDataModel.Order_Details.Orders" /> w podanej encji typu <see cref="T:MoxDataModel.Order_Details" />.
/// </summary>
		public void LoadOrders(Order_Details order_details)
		{
			if (order_details.EntityState == EntityState.Unchanged ||
				order_details.EntityState == EntityState.Modified)
			{
				order_details.OrdersRelatedEnd.Load();
			}
		}
				
/// <summary>
/// Sprawdza, czy dla danej encji typu <see cref="T:MoxDataModel.Order_Details" /> jest załadowana powiązana encja osiągalna przez własność <see cref="P:MoxDataModel.Order_Details.Products" />.
/// </summary>
		public bool IsProductsLoaded(Order_Details order_details)
		{
			return order_details.ProductsRelatedEnd.IsLoaded;
		}
		
/// <summary>
/// Ładuje powiązaną encję osiągalną przez własność <see cref="P:MoxDataModel.Order_Details.Products" /> w podanej encji typu <see cref="T:MoxDataModel.Order_Details" />.
/// </summary>
		public void LoadProducts(Order_Details order_details)
		{
			if (order_details.EntityState == EntityState.Unchanged ||
				order_details.EntityState == EntityState.Modified)
			{
				order_details.ProductsRelatedEnd.Load();
			}
		}
				
	}

	
/// <summary>
/// Ładuje encje bezpośrednio powiązane z encjami typu <see cref="T:MoxDataModel.Orders" />
/// </summary>
	[System.CodeDom.Compiler.GeneratedCodeAttribute("InsERT.Mox.DataModeling.DataModelCSharpCodeGenerator", "1.0.0.0")]
	
	public interface IOrdersRelationshipLoader
	{
/// <summary>
/// Sprawdza, czy dla danej encji typu <see cref="T:MoxDataModel.Orders" /> jest załadowana powiązana encja osiągalna przez własność <see cref="P:MoxDataModel.Orders.Customers" />.
/// </summary>
		bool IsCustomersLoaded(Orders orders);		
/// <summary>
/// Ładuje powiązaną encję osiągalną przez własność <see cref="P:MoxDataModel.Orders.Customers" /> w podanej encji typu <see cref="T:MoxDataModel.Orders" />.
/// </summary>
		void LoadCustomers(Orders orders);
/// <summary>
/// Sprawdza, czy dla danej encji typu <see cref="T:MoxDataModel.Orders" /> jest załadowana powiązana encja osiągalna przez własność <see cref="P:MoxDataModel.Orders.Employees" />.
/// </summary>
		bool IsEmployeesLoaded(Orders orders);		
/// <summary>
/// Ładuje powiązaną encję osiągalną przez własność <see cref="P:MoxDataModel.Orders.Employees" /> w podanej encji typu <see cref="T:MoxDataModel.Orders" />.
/// </summary>
		void LoadEmployees(Orders orders);
/// <summary>
/// Sprawdza, czy dla danej encji typu <see cref="T:MoxDataModel.Orders" /> są załadowane powiązane encje osiągalne przez własność <see cref="P:MoxDataModel.Orders.Order_Details" />.
/// </summary>
		bool AreOrder_DetailsLoaded(Orders orders);
/// <summary>
/// Ładuje powiązane encje osiągalne przez własność <see cref="P:MoxDataModel.Orders.Order_Details" /> w podanej encji typu <see cref="T:MoxDataModel.Orders" />.
/// </summary>
		void LoadOrder_Details(Orders orders);
/// <summary>
/// Sprawdza, czy dla danej encji typu <see cref="T:MoxDataModel.Orders" /> jest załadowana powiązana encja osiągalna przez własność <see cref="P:MoxDataModel.Orders.Shippers" />.
/// </summary>
		bool IsShippersLoaded(Orders orders);		
/// <summary>
/// Ładuje powiązaną encję osiągalną przez własność <see cref="P:MoxDataModel.Orders.Shippers" /> w podanej encji typu <see cref="T:MoxDataModel.Orders" />.
/// </summary>
		void LoadShippers(Orders orders);
	}
	
/// <summary>
/// Repozytorium encji typu <see cref="T:MoxDataModel.Orders" />
/// </summary>
	[System.CodeDom.Compiler.GeneratedCodeAttribute("InsERT.Mox.DataModeling.DataModelCSharpCodeGenerator", "1.0.0.0")]
	public interface IOrdersRepository
		: IRepository<Orders, System.Int32>
		, IOrdersRelationshipLoader
	{
	}
	
/// <summary>
/// Repozytorium encji typu <see cref="MoxDataModel.Orders" /> ze zbioru Orders.
/// </summary>
	[System.CodeDom.Compiler.GeneratedCodeAttribute("InsERT.Mox.DataModeling.DataModelCSharpCodeGenerator", "1.0.0.0")]
	public class EFOrdersFromOrdersRepository
		: EFRepositoryBase<Orders, Orders, System.Int32, dbo>
		, IOrdersRepository
		, InsERT.Mox.ObiektyBiznesowe.IDane<Orders>
	{
/// <summary>
/// Tworzy repozytorium pobierające encje w podanym kontekście ADO.NET EF.
/// </summary>
		public EFOrdersFromOrdersRepository(dbo objectContext)
			: base(objectContext)
		{
		}
		
/// <summary>
/// Zbiór encji, z którego korzysta repozytorium.
/// </summary>
		protected override ObjectSet<Orders> ObjectSet
		{
			get
			{
				return ObjectContext.Orders;
			}
		}
		
/// <summary>
/// Sprawdza, czy dla danej encji typu <see cref="T:MoxDataModel.Orders" /> jest załadowana powiązana encja osiągalna przez własność <see cref="P:MoxDataModel.Orders.Customers" />.
/// </summary>
		public bool IsCustomersLoaded(Orders orders)
		{
			return orders.CustomersRelatedEnd.IsLoaded;
		}
		
/// <summary>
/// Ładuje powiązaną encję osiągalną przez własność <see cref="P:MoxDataModel.Orders.Customers" /> w podanej encji typu <see cref="T:MoxDataModel.Orders" />.
/// </summary>
		public void LoadCustomers(Orders orders)
		{
			if (orders.EntityState == EntityState.Unchanged ||
				orders.EntityState == EntityState.Modified)
			{
				orders.CustomersRelatedEnd.Load();
			}
		}
				
/// <summary>
/// Sprawdza, czy dla danej encji typu <see cref="T:MoxDataModel.Orders" /> jest załadowana powiązana encja osiągalna przez własność <see cref="P:MoxDataModel.Orders.Employees" />.
/// </summary>
		public bool IsEmployeesLoaded(Orders orders)
		{
			return orders.EmployeesRelatedEnd.IsLoaded;
		}
		
/// <summary>
/// Ładuje powiązaną encję osiągalną przez własność <see cref="P:MoxDataModel.Orders.Employees" /> w podanej encji typu <see cref="T:MoxDataModel.Orders" />.
/// </summary>
		public void LoadEmployees(Orders orders)
		{
			if (orders.EntityState == EntityState.Unchanged ||
				orders.EntityState == EntityState.Modified)
			{
				orders.EmployeesRelatedEnd.Load();
			}
		}
				
/// <summary>
/// Sprawdza, czy dla danej encji typu <see cref="T:MoxDataModel.Orders" /> są załadowane powiązane encje osiągalne przez własność <see cref="P:MoxDataModel.Orders.Order_Details" />.
/// </summary>
		public bool AreOrder_DetailsLoaded(Orders orders)
		{
			return orders.Order_DetailsRelatedEnd.IsLoaded;
		}
		
/// <summary>
/// Ładuje powiązane encje osiągalne przez własność <see cref="P:MoxDataModel.Orders.Order_Details" /> w podanej encji typu <see cref="T:MoxDataModel.Orders" />.
/// </summary>
		public void LoadOrder_Details(Orders orders)
		{
			if (orders.EntityState == EntityState.Unchanged ||
				orders.EntityState == EntityState.Modified)
			{
				orders.Order_DetailsRelatedEnd.Load();
			}
		}
				
/// <summary>
/// Sprawdza, czy dla danej encji typu <see cref="T:MoxDataModel.Orders" /> jest załadowana powiązana encja osiągalna przez własność <see cref="P:MoxDataModel.Orders.Shippers" />.
/// </summary>
		public bool IsShippersLoaded(Orders orders)
		{
			return orders.ShippersRelatedEnd.IsLoaded;
		}
		
/// <summary>
/// Ładuje powiązaną encję osiągalną przez własność <see cref="P:MoxDataModel.Orders.Shippers" /> w podanej encji typu <see cref="T:MoxDataModel.Orders" />.
/// </summary>
		public void LoadShippers(Orders orders)
		{
			if (orders.EntityState == EntityState.Unchanged ||
				orders.EntityState == EntityState.Modified)
			{
				orders.ShippersRelatedEnd.Load();
			}
		}
				
	}

	
/// <summary>
/// Ładuje encje bezpośrednio powiązane z encjami typu <see cref="T:MoxDataModel.Products" />
/// </summary>
	[System.CodeDom.Compiler.GeneratedCodeAttribute("InsERT.Mox.DataModeling.DataModelCSharpCodeGenerator", "1.0.0.0")]
	
	public interface IProductsRelationshipLoader
	{
/// <summary>
/// Sprawdza, czy dla danej encji typu <see cref="T:MoxDataModel.Products" /> jest załadowana powiązana encja osiągalna przez własność <see cref="P:MoxDataModel.Products.Categories" />.
/// </summary>
		bool IsCategoriesLoaded(Products products);		
/// <summary>
/// Ładuje powiązaną encję osiągalną przez własność <see cref="P:MoxDataModel.Products.Categories" /> w podanej encji typu <see cref="T:MoxDataModel.Products" />.
/// </summary>
		void LoadCategories(Products products);
/// <summary>
/// Sprawdza, czy dla danej encji typu <see cref="T:MoxDataModel.Products" /> są załadowane powiązane encje osiągalne przez własność <see cref="P:MoxDataModel.Products.Order_Details" />.
/// </summary>
		bool AreOrder_DetailsLoaded(Products products);
/// <summary>
/// Ładuje powiązane encje osiągalne przez własność <see cref="P:MoxDataModel.Products.Order_Details" /> w podanej encji typu <see cref="T:MoxDataModel.Products" />.
/// </summary>
		void LoadOrder_Details(Products products);
/// <summary>
/// Sprawdza, czy dla danej encji typu <see cref="T:MoxDataModel.Products" /> jest załadowana powiązana encja osiągalna przez własność <see cref="P:MoxDataModel.Products.Suppliers" />.
/// </summary>
		bool IsSuppliersLoaded(Products products);		
/// <summary>
/// Ładuje powiązaną encję osiągalną przez własność <see cref="P:MoxDataModel.Products.Suppliers" /> w podanej encji typu <see cref="T:MoxDataModel.Products" />.
/// </summary>
		void LoadSuppliers(Products products);
	}
	
/// <summary>
/// Repozytorium encji typu <see cref="T:MoxDataModel.Products" />
/// </summary>
	[System.CodeDom.Compiler.GeneratedCodeAttribute("InsERT.Mox.DataModeling.DataModelCSharpCodeGenerator", "1.0.0.0")]
	public interface IProductsRepository
		: IRepository<Products, System.Int32>
		, IProductsRelationshipLoader
	{
	}
	
/// <summary>
/// Repozytorium encji typu <see cref="MoxDataModel.Products" /> ze zbioru Products.
/// </summary>
	[System.CodeDom.Compiler.GeneratedCodeAttribute("InsERT.Mox.DataModeling.DataModelCSharpCodeGenerator", "1.0.0.0")]
	public class EFProductsFromProductsRepository
		: EFRepositoryBase<Products, Products, System.Int32, dbo>
		, IProductsRepository
		, InsERT.Mox.ObiektyBiznesowe.IDane<Products>
	{
/// <summary>
/// Tworzy repozytorium pobierające encje w podanym kontekście ADO.NET EF.
/// </summary>
		public EFProductsFromProductsRepository(dbo objectContext)
			: base(objectContext)
		{
		}
		
/// <summary>
/// Zbiór encji, z którego korzysta repozytorium.
/// </summary>
		protected override ObjectSet<Products> ObjectSet
		{
			get
			{
				return ObjectContext.Products;
			}
		}
		
/// <summary>
/// Sprawdza, czy dla danej encji typu <see cref="T:MoxDataModel.Products" /> jest załadowana powiązana encja osiągalna przez własność <see cref="P:MoxDataModel.Products.Categories" />.
/// </summary>
		public bool IsCategoriesLoaded(Products products)
		{
			return products.CategoriesRelatedEnd.IsLoaded;
		}
		
/// <summary>
/// Ładuje powiązaną encję osiągalną przez własność <see cref="P:MoxDataModel.Products.Categories" /> w podanej encji typu <see cref="T:MoxDataModel.Products" />.
/// </summary>
		public void LoadCategories(Products products)
		{
			if (products.EntityState == EntityState.Unchanged ||
				products.EntityState == EntityState.Modified)
			{
				products.CategoriesRelatedEnd.Load();
			}
		}
				
/// <summary>
/// Sprawdza, czy dla danej encji typu <see cref="T:MoxDataModel.Products" /> są załadowane powiązane encje osiągalne przez własność <see cref="P:MoxDataModel.Products.Order_Details" />.
/// </summary>
		public bool AreOrder_DetailsLoaded(Products products)
		{
			return products.Order_DetailsRelatedEnd.IsLoaded;
		}
		
/// <summary>
/// Ładuje powiązane encje osiągalne przez własność <see cref="P:MoxDataModel.Products.Order_Details" /> w podanej encji typu <see cref="T:MoxDataModel.Products" />.
/// </summary>
		public void LoadOrder_Details(Products products)
		{
			if (products.EntityState == EntityState.Unchanged ||
				products.EntityState == EntityState.Modified)
			{
				products.Order_DetailsRelatedEnd.Load();
			}
		}
				
/// <summary>
/// Sprawdza, czy dla danej encji typu <see cref="T:MoxDataModel.Products" /> jest załadowana powiązana encja osiągalna przez własność <see cref="P:MoxDataModel.Products.Suppliers" />.
/// </summary>
		public bool IsSuppliersLoaded(Products products)
		{
			return products.SuppliersRelatedEnd.IsLoaded;
		}
		
/// <summary>
/// Ładuje powiązaną encję osiągalną przez własność <see cref="P:MoxDataModel.Products.Suppliers" /> w podanej encji typu <see cref="T:MoxDataModel.Products" />.
/// </summary>
		public void LoadSuppliers(Products products)
		{
			if (products.EntityState == EntityState.Unchanged ||
				products.EntityState == EntityState.Modified)
			{
				products.SuppliersRelatedEnd.Load();
			}
		}
				
	}

	
/// <summary>
/// Ładuje encje bezpośrednio powiązane z encjami typu <see cref="T:MoxDataModel.Shippers" />
/// </summary>
	[System.CodeDom.Compiler.GeneratedCodeAttribute("InsERT.Mox.DataModeling.DataModelCSharpCodeGenerator", "1.0.0.0")]
	
	public interface IShippersRelationshipLoader
	{
/// <summary>
/// Sprawdza, czy dla danej encji typu <see cref="T:MoxDataModel.Shippers" /> są załadowane powiązane encje osiągalne przez własność <see cref="P:MoxDataModel.Shippers.Orders" />.
/// </summary>
		bool AreOrdersLoaded(Shippers shippers);
/// <summary>
/// Ładuje powiązane encje osiągalne przez własność <see cref="P:MoxDataModel.Shippers.Orders" /> w podanej encji typu <see cref="T:MoxDataModel.Shippers" />.
/// </summary>
		void LoadOrders(Shippers shippers);
	}
	
/// <summary>
/// Repozytorium encji typu <see cref="T:MoxDataModel.Shippers" />
/// </summary>
	[System.CodeDom.Compiler.GeneratedCodeAttribute("InsERT.Mox.DataModeling.DataModelCSharpCodeGenerator", "1.0.0.0")]
	public interface IShippersRepository
		: IRepository<Shippers, System.Int32>
		, IShippersRelationshipLoader
	{
	}
	
/// <summary>
/// Repozytorium encji typu <see cref="MoxDataModel.Shippers" /> ze zbioru Shippers.
/// </summary>
	[System.CodeDom.Compiler.GeneratedCodeAttribute("InsERT.Mox.DataModeling.DataModelCSharpCodeGenerator", "1.0.0.0")]
	public class EFShippersFromShippersRepository
		: EFRepositoryBase<Shippers, Shippers, System.Int32, dbo>
		, IShippersRepository
		, InsERT.Mox.ObiektyBiznesowe.IDane<Shippers>
	{
/// <summary>
/// Tworzy repozytorium pobierające encje w podanym kontekście ADO.NET EF.
/// </summary>
		public EFShippersFromShippersRepository(dbo objectContext)
			: base(objectContext)
		{
		}
		
/// <summary>
/// Zbiór encji, z którego korzysta repozytorium.
/// </summary>
		protected override ObjectSet<Shippers> ObjectSet
		{
			get
			{
				return ObjectContext.Shippers;
			}
		}
		
/// <summary>
/// Sprawdza, czy dla danej encji typu <see cref="T:MoxDataModel.Shippers" /> są załadowane powiązane encje osiągalne przez własność <see cref="P:MoxDataModel.Shippers.Orders" />.
/// </summary>
		public bool AreOrdersLoaded(Shippers shippers)
		{
			return shippers.OrdersRelatedEnd.IsLoaded;
		}
		
/// <summary>
/// Ładuje powiązane encje osiągalne przez własność <see cref="P:MoxDataModel.Shippers.Orders" /> w podanej encji typu <see cref="T:MoxDataModel.Shippers" />.
/// </summary>
		public void LoadOrders(Shippers shippers)
		{
			if (shippers.EntityState == EntityState.Unchanged ||
				shippers.EntityState == EntityState.Modified)
			{
				shippers.OrdersRelatedEnd.Load();
			}
		}
				
	}

	
/// <summary>
/// Ładuje encje bezpośrednio powiązane z encjami typu <see cref="T:MoxDataModel.Suppliers" />
/// </summary>
	[System.CodeDom.Compiler.GeneratedCodeAttribute("InsERT.Mox.DataModeling.DataModelCSharpCodeGenerator", "1.0.0.0")]
	
	public interface ISuppliersRelationshipLoader
	{
/// <summary>
/// Sprawdza, czy dla danej encji typu <see cref="T:MoxDataModel.Suppliers" /> są załadowane powiązane encje osiągalne przez własność <see cref="P:MoxDataModel.Suppliers.Products" />.
/// </summary>
		bool AreProductsLoaded(Suppliers suppliers);
/// <summary>
/// Ładuje powiązane encje osiągalne przez własność <see cref="P:MoxDataModel.Suppliers.Products" /> w podanej encji typu <see cref="T:MoxDataModel.Suppliers" />.
/// </summary>
		void LoadProducts(Suppliers suppliers);
	}
	
/// <summary>
/// Repozytorium encji typu <see cref="T:MoxDataModel.Suppliers" />
/// </summary>
	[System.CodeDom.Compiler.GeneratedCodeAttribute("InsERT.Mox.DataModeling.DataModelCSharpCodeGenerator", "1.0.0.0")]
	public interface ISuppliersRepository
		: IRepository<Suppliers, System.Int32>
		, ISuppliersRelationshipLoader
	{
	}
	
/// <summary>
/// Repozytorium encji typu <see cref="MoxDataModel.Suppliers" /> ze zbioru Suppliers.
/// </summary>
	[System.CodeDom.Compiler.GeneratedCodeAttribute("InsERT.Mox.DataModeling.DataModelCSharpCodeGenerator", "1.0.0.0")]
	public class EFSuppliersFromSuppliersRepository
		: EFRepositoryBase<Suppliers, Suppliers, System.Int32, dbo>
		, ISuppliersRepository
		, InsERT.Mox.ObiektyBiznesowe.IDane<Suppliers>
	{
/// <summary>
/// Tworzy repozytorium pobierające encje w podanym kontekście ADO.NET EF.
/// </summary>
		public EFSuppliersFromSuppliersRepository(dbo objectContext)
			: base(objectContext)
		{
		}
		
/// <summary>
/// Zbiór encji, z którego korzysta repozytorium.
/// </summary>
		protected override ObjectSet<Suppliers> ObjectSet
		{
			get
			{
				return ObjectContext.Suppliers;
			}
		}
		
/// <summary>
/// Sprawdza, czy dla danej encji typu <see cref="T:MoxDataModel.Suppliers" /> są załadowane powiązane encje osiągalne przez własność <see cref="P:MoxDataModel.Suppliers.Products" />.
/// </summary>
		public bool AreProductsLoaded(Suppliers suppliers)
		{
			return suppliers.ProductsRelatedEnd.IsLoaded;
		}
		
/// <summary>
/// Ładuje powiązane encje osiągalne przez własność <see cref="P:MoxDataModel.Suppliers.Products" /> w podanej encji typu <see cref="T:MoxDataModel.Suppliers" />.
/// </summary>
		public void LoadProducts(Suppliers suppliers)
		{
			if (suppliers.EntityState == EntityState.Unchanged ||
				suppliers.EntityState == EntityState.Modified)
			{
				suppliers.ProductsRelatedEnd.Load();
			}
		}
				
	}

	
	
	#endregion

	#region entity containers
	
/// <summary>
/// Kontekst obiektowy ADO.NET EF.
/// </summary>
	[System.CodeDom.Compiler.GeneratedCodeAttribute("InsERT.Mox.DataModeling.DataModelCSharpCodeGenerator", "1.0.0.0")]
	public class dbo :  UnitOfWorkAwareObjectContext  
	{

/// <summary>
/// Tworzy kontekst, connection string pobierając z app.config.
/// </summary>
		public dbo()
			: base("name=dbo", "dbo")
		{
			MetadataWorkspace.LoadFromAssembly(Assembly.GetExecutingAssembly());
		}

/// <summary>
/// Tworzy kontekst używający podanego connection stringa.
/// </summary>
		public dbo(string connectionString)
			: base(connectionString, "dbo")
		{
			MetadataWorkspace.LoadFromAssembly(Assembly.GetExecutingAssembly());
		}
		
/// <summary>
/// Tworzy kontekst używający podanego połączenia.
/// </summary>
		public dbo(EntityConnection connection)
			: base(connection, "dbo")
		{
			MetadataWorkspace.LoadFromAssembly(Assembly.GetExecutingAssembly());
		}
		
		private ObjectSet<Categories> _Categories;

/// <summary>
/// Encje ze zbioru Categories.
/// </summary>
	public ObjectSet<Categories> Categories
		{
			get
			{
				if (_Categories == null)
				{
					_Categories = CreateObjectSet<Categories>("Categories");
				}
				return _Categories;
			}
		}
		
		private ObjectSet<Customers> _Customers;

/// <summary>
/// Encje ze zbioru Customers.
/// </summary>
	public ObjectSet<Customers> Customers
		{
			get
			{
				if (_Customers == null)
				{
					_Customers = CreateObjectSet<Customers>("Customers");
				}
				return _Customers;
			}
		}
		
		private ObjectSet<Employees> _Employees;

/// <summary>
/// Encje ze zbioru Employees.
/// </summary>
	public ObjectSet<Employees> Employees
		{
			get
			{
				if (_Employees == null)
				{
					_Employees = CreateObjectSet<Employees>("Employees");
				}
				return _Employees;
			}
		}
		
		private ObjectSet<Order_Details> _Order_Details;

/// <summary>
/// Encje ze zbioru Order_Details.
/// </summary>
	public ObjectSet<Order_Details> Order_Details
		{
			get
			{
				if (_Order_Details == null)
				{
					_Order_Details = CreateObjectSet<Order_Details>("Order_Details");
				}
				return _Order_Details;
			}
		}
		
		private ObjectSet<Orders> _Orders;

/// <summary>
/// Encje ze zbioru Orders.
/// </summary>
	public ObjectSet<Orders> Orders
		{
			get
			{
				if (_Orders == null)
				{
					_Orders = CreateObjectSet<Orders>("Orders");
				}
				return _Orders;
			}
		}
		
		private ObjectSet<Products> _Products;

/// <summary>
/// Encje ze zbioru Products.
/// </summary>
	public ObjectSet<Products> Products
		{
			get
			{
				if (_Products == null)
				{
					_Products = CreateObjectSet<Products>("Products");
				}
				return _Products;
			}
		}
		
		private ObjectSet<Shippers> _Shippers;

/// <summary>
/// Encje ze zbioru Shippers.
/// </summary>
	public ObjectSet<Shippers> Shippers
		{
			get
			{
				if (_Shippers == null)
				{
					_Shippers = CreateObjectSet<Shippers>("Shippers");
				}
				return _Shippers;
			}
		}
		
		private ObjectSet<Suppliers> _Suppliers;

/// <summary>
/// Encje ze zbioru Suppliers.
/// </summary>
	public ObjectSet<Suppliers> Suppliers
		{
			get
			{
				if (_Suppliers == null)
				{
					_Suppliers = CreateObjectSet<Suppliers>("Suppliers");
				}
				return _Suppliers;
			}
		}
		
	}	

	#endregion

	#region model-defined constraint validation helpers
	

	
	#endregion

	#region module manifest
	
	/// <summary>
	/// Ta klasa jest wykorzystywana przez wewnętrzne mechanizmy platformy Morii i nie powinna być bezpośrednio używana w kodzie zewnętrznym.
	/// </summary>
	[System.CodeDom.Compiler.GeneratedCodeAttribute("InsERT.Mox.DataModeling.DataModelCSharpCodeGenerator", "1.0.0.0")]
	public sealed class ModuleManifest : InsERT.Mox.Runtime.EntityFramework.IEdmModuleManifest
	{
		/// <summary>
		/// Ta własność jest wykorzystywana przez wewnętrzne mechanizmy platformy Morii i nie powinna być bezpośrednio używana w kodzie zewnętrznym.
		/// </summary>
		public IEnumerable<Type> ObjectContextTypes 
		{ 
			get
			{
				return new[]
				{
					typeof(dbo),
				};
			}
		}
		
		/// <summary>
		/// Ta własność jest wykorzystywana przez wewnętrzne mechanizmy platformy Morii i nie powinna być bezpośrednio używana w kodzie zewnętrznym.
		/// </summary>
		public IEnumerable<InsERT.Mox.Runtime.EntityFramework.RepositoryRegistration> RepositoryRegistrations
		{
			get
			{
				return new[]
				{
				new InsERT.Mox.Runtime.EntityFramework.RepositoryRegistration
				(
					typeof(ICategoriesRepository),
					new Type[] { typeof(InsERT.Mox.ObiektyBiznesowe.IDane<Categories>), typeof(IRepository<Categories>), typeof(IRepository<Categories, System.Int32>) },
					new Tuple<Type, string, Type>[]
					{ 
						Tuple.Create(typeof(dbo), "Categories", typeof(EFCategoriesFromCategoriesRepository)),
					},
					"Categories" 
				),
				new InsERT.Mox.Runtime.EntityFramework.RepositoryRegistration
				(
					typeof(ICustomersRepository),
					new Type[] { typeof(InsERT.Mox.ObiektyBiznesowe.IDane<Customers>), typeof(IRepository<Customers>), typeof(IRepository<Customers, System.String>) },
					new Tuple<Type, string, Type>[]
					{ 
						Tuple.Create(typeof(dbo), "Customers", typeof(EFCustomersFromCustomersRepository)),
					},
					"Customers" 
				),
				new InsERT.Mox.Runtime.EntityFramework.RepositoryRegistration
				(
					typeof(IEmployeesRepository),
					new Type[] { typeof(InsERT.Mox.ObiektyBiznesowe.IDane<Employees>), typeof(IRepository<Employees>), typeof(IRepository<Employees, System.Int32>) },
					new Tuple<Type, string, Type>[]
					{ 
						Tuple.Create(typeof(dbo), "Employees", typeof(EFEmployeesFromEmployeesRepository)),
					},
					"Employees" 
				),
				new InsERT.Mox.Runtime.EntityFramework.RepositoryRegistration
				(
					typeof(IOrder_DetailsRepository),
					new Type[] { typeof(InsERT.Mox.ObiektyBiznesowe.IDane<Order_Details>), typeof(IRepository<Order_Details>) },
					new Tuple<Type, string, Type>[]
					{ 
						Tuple.Create(typeof(dbo), "Order_Details", typeof(EFOrder_DetailsFromOrder_DetailsRepository)),
					},
					"Order_Details" 
				),
				new InsERT.Mox.Runtime.EntityFramework.RepositoryRegistration
				(
					typeof(IOrdersRepository),
					new Type[] { typeof(InsERT.Mox.ObiektyBiznesowe.IDane<Orders>), typeof(IRepository<Orders>), typeof(IRepository<Orders, System.Int32>) },
					new Tuple<Type, string, Type>[]
					{ 
						Tuple.Create(typeof(dbo), "Orders", typeof(EFOrdersFromOrdersRepository)),
					},
					"Orders" 
				),
				new InsERT.Mox.Runtime.EntityFramework.RepositoryRegistration
				(
					typeof(IProductsRepository),
					new Type[] { typeof(InsERT.Mox.ObiektyBiznesowe.IDane<Products>), typeof(IRepository<Products>), typeof(IRepository<Products, System.Int32>) },
					new Tuple<Type, string, Type>[]
					{ 
						Tuple.Create(typeof(dbo), "Products", typeof(EFProductsFromProductsRepository)),
					},
					"Products" 
				),
				new InsERT.Mox.Runtime.EntityFramework.RepositoryRegistration
				(
					typeof(IShippersRepository),
					new Type[] { typeof(InsERT.Mox.ObiektyBiznesowe.IDane<Shippers>), typeof(IRepository<Shippers>), typeof(IRepository<Shippers, System.Int32>) },
					new Tuple<Type, string, Type>[]
					{ 
						Tuple.Create(typeof(dbo), "Shippers", typeof(EFShippersFromShippersRepository)),
					},
					"Shippers" 
				),
				new InsERT.Mox.Runtime.EntityFramework.RepositoryRegistration
				(
					typeof(ISuppliersRepository),
					new Type[] { typeof(InsERT.Mox.ObiektyBiznesowe.IDane<Suppliers>), typeof(IRepository<Suppliers>), typeof(IRepository<Suppliers, System.Int32>) },
					new Tuple<Type, string, Type>[]
					{ 
						Tuple.Create(typeof(dbo), "Suppliers", typeof(EFSuppliersFromSuppliersRepository)),
					},
					"Suppliers" 
				),
				};
			}
		}
	}
	
	#endregion

}
