﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using MoxDataModel;

namespace TestApp
{
    public class ReportData
    {
        public Customers Entity { get; protected set; }

        private ICollection<OrderWrapper> _orders;
        public ICollection<OrderWrapper> Orders
        {
            get
            {
                if (_orders == null)
                {
                    _orders = new List<OrderWrapper>();
                    foreach (var order in Entity.Orders)
                    {
                        _orders.Add(new OrderWrapper(order));
                    }
                }
                return _orders;
            }
        }

        public int OrdersCount { get { return Entity.Orders.Count; } }

        public ReportData(Customers entity)
        {
            Entity = entity;
        }
    }

    public class OrderWrapper
    {
        public Orders Order { get; protected set; }

        

        private ICollection<DetailsWrapper> _details;
        public ICollection<DetailsWrapper> Details
        {
            get
            {
                if (_details == null)
                {
                    _details = new List<DetailsWrapper>();
                    foreach (var details in Order.Order_Details)
                    {
                        _details.Add(new DetailsWrapper(details));
                    }
                }
                return _details;
            }
        }

        public OrderWrapper(Orders order)
        {
            Order = order;
        }
    }

    public class DetailsWrapper
    {
        public Order_Details Details { get; protected set; }

        public DetailsWrapper(Order_Details details)
        {
            Details = details;
        }
    }
}
